//obsluha zalozky pro upravu davky prikazu
const MAX_COLORS=15;

function ListIndexNameToAGroupIndex(Index:integer):Integer;
var i:Integer;
begin
  Result:=0;
  for i:=0 to aGroups.Count-1 do begin
    if(FiltForm_Groups.Items[Index]=aGroups[i+INDEX_NAME]) then begin
      Result:=i/3;
      i:=aGroups.Count-1;
    end
    else i:=i+2;
  end;
end;

var aFontItem:array[0..MAX_COLORS] of record
      sName:string;
      iColor:integer;
      iBkgColor:integer;
      iStyle:TFontStyles;
    end;
  naFontItem:Integer;
  bClick:boolean; //priznak vyvolani obsluhy *.Checked kliknutim na prvek

function FindIndexColor(sType:string):integer;
var i,ierr:Integer;
begin
  ierr:=-1;
  Result:=-1;
  for i:=0 to MAX_COLORS-1 do begin
    if(aFontItem[i].sName=sType) then begin Result:=i; i:=MAX_COLORS-1; end;
    if(aFontItem[i].sName='ERR') then ierr:=i;
  end;
  if(Result<0) then Result:=ierr;
end;

procedure Actions_DrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte {podle dokumentace je typu TOwnerDrawState, ale v enginu je byte});
var s,s1,s2:string;
  x:integer;
  iErr:integer;
begin
  with FiltEdit_Actions.Canvas do begin
    s:=TrimErrFlag(FiltEdit_Actions.Items[Index],iErr);
    s2:=s;
    s1:=fetch(s,'=');
    //podle typu pouzijeme barvu pozadi a popredi, pokud je focus, implicitni
    if(s1='') then s1:='EMPTY';
    x:=FindIndexColor(s1);
    Brush.Color:=aFontItem[x].iBkgColor;
    if(iErr=1) then Brush.Color:=STYLE_BKGCOLOR_WARN;
    if(iErr=2) then Brush.Color:=STYLE_BKGCOLOR_ERROR;
    Font.Color:=aFontItem[x].iColor;
    Font.Style:=aFontItem[x].iStyle;
    if((State AND 1)=1) then begin
      Brush.Color:=STYLE_BKGCOLOR_SELECTED;
      Font.Color:=STYLE_COLOR_SELECTED;
      //Font.Style:=[];    //nechame puvodni styl, menime jen narvy
    end;
    FillRect(Rect);
    TextOut(Rect.Left+6,Rect.Top+2,s2);
    //TextOut(Rect.Left+6,Rect.Top+2,FiltEdit_Actions.Items[Index]);
  end;
end;

function SwapRB(rgb:string):string;
begin //prohodi barvy, intel ma INT obracene polozky
  Result:=copy(rgb,5,2)+copy(rgb,3,2)+copy(rgb,1,2);
end;

procedure InitColors;
var
    s,s1,sIni:string;
    a:TStringList;
begin
  sIni:=FileToString(GetCombineDir+'Combine.Colors.ini'); //nacteme barvy
  naFontItem:=0;
  while (sIni<>'') do begin
    s1:=fetch(sIni,CRLF);
    a:=StrToList(ReplaceString(s1,',',CRLF));
    if((a.Strings[0]<>'') and (a.count>=2)) then begin
      s:=a.Strings[0];
      s1:=fetch(s,'=');
      aFontItem[naFontItem].sName:=s1;
      aFontItem[naFontItem].iColor:=StrToInt('$'+SwapRB(s));
      aFontItem[naFontItem].iBkgColor:=StrToInt('$'+SwapRB(a[1]));
      if(a.count>2) then begin
        if(RegexFind('Bold',a[2])) then aFontItem[naFontItem].iStyle:=[fsBold];
        if(RegexFind('Italic',a[2])) then
          aFontItem[naFontItem].iStyle:=aFontItem[naFontItem].iStyle+[fsItalic];
      end;
      naFontItem:=naFontItem+1;
    end;
    a.Free();
  end;
end;

procedure SaveOnClick(sender:TObject);
var s,sPath:string;
    i,iErr:Integer;
begin
  //prejmenovat puvodni soubor
  i:=ListIndexNameToAGroupIndex(FiltForm_Groups.ItemIndex);
  sPath:=GetPathnameFromMacroname(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex],'ini');  //RenameFile(sPath,sPath+'_old');
  DeleteFile(sPath);
  //ulozit vse do noveho
  aGroups[i*3+INDEX_COMMENT]:=FiltEdit_EditComment.Text;
  s:='[Group]'+CRLF;
  s:=s+'Name='+aGroups[i*3]+CRLF;
  s:=s+'Comment='+aGroups[i*3+2]+CRLF;
  s:=s+'Icon='+aGroups[i*3+1]+CRLF;
  //a ted vsechny polozky
  for i:=0 to FiltEdit_Actions.Items.Count-1 do begin
    s:=s+TrimErrFlag(FiltEdit_Actions.Items[i],iErr)+CRLF;
  end;
  StringToFile(s,sPath);
  OnNoChange();
end;

procedure IsSaved;
begin
  if(FiltEdit_ActionsChange.Checked) then
  begin
    if(6=MessBox(_('The changes in batch were not saved.')+CRLF
      +_('Save it before continue?')+CRLF,_('The changes in batch'),4))
      then SaveOnClick(nil);
  end;
end;

procedure SetSetAddSub;
begin
  if(FiltEdit_Actions.ItemIndex<>-1) then begin
    bClick:=false;
    case copy(sAktAction,4,4) of
    '_SET': FiltEdit_SetAddSub.ItemIndex:=0;
    '_ADD': FiltEdit_SetAddSub.ItemIndex:=1;
    '_SUB': FiltEdit_SetAddSub.ItemIndex:=2;
    end;
    bClick:=true;
  end;
end;

procedure SetConditioned;
begin
  if(FiltEdit_Actions.ItemIndex<>-1) then begin
    bClick:=false;
    case sAktConditioned of
    '+': FiltEdit_Test.ItemIndex:=1;
    '-': FiltEdit_Test.ItemIndex:=2;
    else FiltEdit_Test.ItemIndex:=0;
    end;
    bClick:=true;
  end;
end;

procedure CancelOnClick(sender:TObject);
begin
  IsSaved();        //pokud je treba, ulozime zmeny
end;

procedure FormOnClose(Sender: TObject; var Action: TCloseAction);
begin
  IsSaved();        //pokud je treba, ulozime zmeny
end;

procedure ActionsOnClick(sender:TObject);
var b:boolean;
begin
  b:=FiltEdit_ActionsChange.Checked; //zapamatujeme si priznak zmen
  if(FiltEdit_Actions.ItemIndex<>-1) then begin
    sAktAction:=GetActionType(FiltEdit_Actions.Items[FiltEdit_Actions.ItemIndex]);
    sAktConditioned:=GetConditioned(FiltEdit_Actions.Items[FiltEdit_Actions.ItemIndex]);
    SetSetAddSub();
    SetConditioned();
  end;
  if(b) then SetActionsEnablesButtons()
  else OnNoChange;
end;

procedure ActionsOnDblClick(sender:TObject);
var ind,n,iErr:integer;
    t,sPath,s,podm:string;
begin
  ind:=FiltEdit_Actions.ItemIndex;
  if(ind>-1) then begin
    n:=0; //neni obslouzeno jinym dialogem
    sPath:=TrimErrFlag(FiltEdit_Actions.Items[ind],iErr);
    t:=fetch(sPath,'=');
    n:=0; //priznak obslouzeni parametru jinym dialogem
    FiltParam_Comment.Caption:=t+'';
    FiltParam_Param.Visible:=true;
    FiltParam_File.Visible:=true;
    FiltParam_Dir.Visible:=false;
    if(t='GGE') then begin
      FiltParam_Comment.Caption:=t
        +_(': Parameters will be used when you start exporting, exe or bat.')+CRLF
        +_('The names of all files must be including the extension.');
      n:=1;
      FiltParam_Comment.Caption:=_('Parameter is the output file (absolute or relative path, file name with extension) for export.');
    end
    else if((t='BAT') or (t='EXE')) then begin n:=1;
      FiltParam_Comment.Caption:=_('Put all the parameters to be used. Parameter that contains spaces it must be enclosed in quotation marks (for example, path and file name extensions, including: "c: \ Program Files \ ... \ soubor.zip")');
    end
    else if((t='CMD')) then begin
      EditParamCmd(false);
      n:=0; //pokud bylo treba, uz je upraveno v seznamu, postarala se o to rutina
    end
    else if((t='CMT')) then begin
      FiltParam_Comment.Caption:=_('Put the comment');
      sPath:='Comment|'+sPath;
      n:=1;
    end
    else if(t='GGS') then begin //cesta ukazuje na *.lnk (zastupce)
      ShowMessage('This item can be changed only in the administration of batchs.');
      n:=0; //pokud bylo treba, uz je upraveno v seznamu, postarala se o to rutina
    end
    else if((copy(t,1,3)='GGF') or (copy(t,1,3)='GGT') or (t='GGP')) then begin
      FiltParam_Param.Visible:=false;
      FiltParam_Comment.Caption:='';
      FiltParam_File.Visible:=false;
      n:=1;
    end
    ;
    if(n<>0) then begin
      podm:=copy(sPath,1,1);
      if((podm='+') or (podm='-')) then sPath:=copy(sPath,2,length(sPath))
      else podm:='';
      s:=sPath;
      FiltParam_Makro.Caption:=fetch(s,'|');
      FiltParam_Param.Text:=s;
      if(FiltParam_Param.Text=sPath) then FiltParam_Param.Text:='';
      FiltParam_Vzdy.Checked:=((podm=''));
      FiltParam_Plati.Checked:=(podm='+');
      FiltParam_Neplati.Checked:=(podm='-');
      n:=FiltParam.ShowModal();
      if(n=1) then begin //prevzit parametry a ulozit do seznamu
        if(t='CMT') then begin
          podm:='';
          FiltParam_Makro.Caption:='';
        end
        else begin
          podm:='';
          if(FiltParam_Plati.Checked) then podm:='+';
          if(FiltParam_Neplati.Checked) then podm:='-';
          if(FiltParam_Param.Text<>'') then FiltParam_Param.Text:='|'+FiltParam_Param.Text;
        end;
        FiltEdit_Actions.Items[ind]:=ReplaceToProm(t+'='+podm+FiltParam_Makro.Caption
          +FiltParam_Param.Text);
        OnChange();
      end;
    end;
    ActionsOnClick(nil);
  end;
end;

procedure ActionCommentOnClick(sender:TObject);
var i:integer;
begin
  //nastavi nebo zrusi priznak zapoznamkovaneho prikazu
  i:=FiltEdit_Actions.ItemIndex;
  if(copy(FiltEdit_Actions.Items[i],1,4)<>'CMT=') then
    FiltEdit_Actions.Items[i]:='CMT='+FiltEdit_Actions.Items[i]
  else
    FiltEdit_Actions.Items[i]:=copy(FiltEdit_Actions.Items[i],5,length(FiltEdit_Actions.Items[i]));
  sAktAction:=GetActionType(FiltEdit_Actions.Items[FiltEdit_Actions.ItemIndex]);
  OnChange();
end;

procedure PolozkaAdd(typ:string);
var sPath,s,s1,sPathStart:string;
    iNeexistuje:integer;
begin
  s1:=_('Add command into batch');
  case typ of
    'GGT_SET': begin s:=_('Lists of GeoGet')+' (*.ggt)|*.ggt'; sPathStart:=Geoget_Datadir; end;
    'GGF_SET': begin s:=_('Filters of GeoGet')+' (*.ggf)|*.ggf'; sPathStart:=Geoget_Datadir; end;
    'GGP': begin s:=_('Program''s scripts of GeoGet')+' (*.ggp.pas)|*.ggp.pas'; sPathStart:=Geoget_Scriptdir; end;
    'GGE': begin s:=_('Export''s scripts of GeoGet')+' (*.gge.pas)|*.gge.pas'; sPathStart:=Geoget_Scriptdir; end;
    'EXE': begin s:=_('Executable files of Windows')+' (*.exe)|*.exe'; sPathStart:=Geoget_Datadir; end;
    'BAT': begin s:=_('Batchs of Windows')+' (*.bat)|*.bat'; sPathStart:=Geoget_Datadir; end;
  end;
  if(s<>'') then begin
    if(OpenDlg(s1,                           //title
               sPathStart,               //InitDir
              'ofFileMustExist,ofHideReadOnly,ofNoChangeDir', //options
              s,   //filtr
              sPath)) then
    begin
      s:=typ;
      s1:=s;
      sPath:=ReplaceToProm(sPath);
      s:=s+'='+sPath;
      if((FiltEdit_Actions.ItemIndex>=0) and (FiltEdit_Actions.ItemIndex<FiltEdit_Actions.Items.Count-1)) then begin
        FiltEdit_Actions.Items.Insert(FiltEdit_Actions.ItemIndex+1,s);
        FiltEdit_Actions.ItemIndex:=FiltEdit_Actions.ItemIndex+1;
      end else begin             //pridat na konec
        FiltEdit_Actions.Items.Add(s);
        FiltEdit_Actions.ItemIndex:=FiltEdit_Actions.Items.Count-1;
      end;
      ActionsOnClick(nil);
      OnChange();
      if(typ='GGE') then ActionsOnDblClick(nil);  //pokud je to gge, musi mit parametr
      IsFileOk(s,FiltEdit_ActionsName.Caption,false,iNeexistuje);
    end;
  end;
end;

procedure FilterAddOnClick(sender:TObject);begin PolozkaAdd('GGF_SET');end;
procedure ListAddOnClick(sender:TObject);begin PolozkaAdd('GGT_SET');end;
procedure GgpAddOnClick(sender:TObject);begin PolozkaAdd('GGP');end;
procedure GgeAddOnClick(sender:TObject);begin PolozkaAdd('GGE');end;
procedure ExeAddOnClick(sender:TObject);begin PolozkaAdd('EXE');end;
procedure BatAddOnClick(sender:TObject);begin PolozkaAdd('BAT');end;

procedure CmdAddOnClick(sender:TObject);
begin
  FiltCmd_Cmds.Enabled:=true; //povolime seznam prikazu
  EditParamCmd(true);
  ActionsOnClick(nil);
end;

procedure ActionUpOnClick(sender:TObject);
var s:string;
    i:Integer;
begin
  i:=FiltEdit_Actions.ItemIndex;
  s:=FiltEdit_Actions.Items[i];
  FiltEdit_Actions.Items.Delete(i);
  FiltEdit_Actions.Items.Insert(i-1,s);
  FiltEdit_Actions.ItemIndex:=i-1;
  OnChange();
  ActionsOnClick(nil);
end;

procedure ActionDownOnClick(sender:TObject);
var s:string;
    i:Integer;
begin
  i:=FiltEdit_Actions.ItemIndex;
  s:=FiltEdit_Actions.Items[i+1];
  FiltEdit_Actions.Items.Delete(i+1);
  FiltEdit_Actions.Items.Insert(i,s);
  FiltEdit_Actions.ItemIndex:=i+1;
  OnChange();
  ActionsOnClick(nil);
end;

procedure SetAddSubOnClick(sender:TObject);
var s:string;
begin
//toto se ale vyvolava i pri programovem nastaveni hodnoty, proto musime testovat
//kdy k tomu dojde
  if(FiltEdit_Actions.ItemIndex>-1) and (bClick) then begin
    s:=FiltEdit_Actions.Items[FiltEdit_Actions.ItemIndex];
    fetch(s,'=');
    if(FiltEdit_SetAddSub.ItemIndex=0) then sAktAction:=copy(sAktAction,1,4)+'SET';
    if(FiltEdit_SetAddSub.ItemIndex=1) then sAktAction:=copy(sAktAction,1,4)+'ADD';
    if(FiltEdit_SetAddSub.ItemIndex=2) then sAktAction:=copy(sAktAction,1,4)+'SUB';
    FiltEdit_Actions.Items[FiltEdit_Actions.ItemIndex]:=sAktAction+'='+s;
    OnChange();
  end;
end;

procedure TestOnClick(sender:TObject);
var s:string;
begin
//toto se ale vyvolava i pri programovem nastaveni hodnoty, proto musime testovat
//kdy k tomu dojde
  if(FiltEdit_Actions.ItemIndex>-1) and (bClick) then begin
    s:=FiltEdit_Actions.Items[FiltEdit_Actions.ItemIndex];
    fetch(s,'=');
    if(sAktConditioned<>'') then s:=copy(s,2,length(s));
    if(FiltEdit_Test.ItemIndex=0) then sAktConditioned:='';
    if(FiltEdit_Test.ItemIndex=1) then sAktConditioned:='+';
    if(FiltEdit_Test.ItemIndex=2) then sAktConditioned:='-';
    FiltEdit_Actions.Items[FiltEdit_Actions.ItemIndex]:=sAktAction+'='+sAktConditioned+s;
    OnChange();
  end;
end;

procedure ActionDelOnClick(sender:TObject);
var i:Integer;
begin
  i:=FiltEdit_Actions.ItemIndex;
  FiltEdit_Actions.Items.Delete(i);
  if(i>=FiltEdit_Actions.Items.Count) then i:=i-1;
  FiltEdit_Actions.ItemIndex:=i;
  OnChange();
  ActionsOnClick(nil);
end;

procedure IkonaOnClick(sender:TObject);
var sPath:string;
  Bitmap:TBitmap;
begin
  //rekneme si o soubor, kam ikonu ulozit
  if(OpenDlg(_('Change of icon batch'),                           //title
             GEOGET_DATADIR,               //InitDir
             'ofFileMustExist,ofHideReadOnly', //options
             _('Icon file')+' (*.bmp)|*.bmp',   //filtr
              sPath)) then begin
    sPath:=EncodeBase64(FileToString(sPath));
    Bitmap:=Base64ToBitmap(sPath);
    aGroups[ListIndexNameToAGroupIndex(FiltForm_Groups.ItemIndex)*3+INDEX_ICON]:=sPath;
    FiltEdit_Ikona.Glyph:=Bitmap;
    Bitmap.Free();
    OnChange();
  end;
end;

procedure SaveBmpOnClick(sender:TObject);
var sPath:string;
begin
  //rekneme si o soubor, kam ikonu ulozit
  if(SaveDlg(_('Save of icon to file'),
    GEOGET_DATADIR,'ofHideReadOnly',_('Icon file')+' (*.bmp)|*.bmp',sPath)) then begin
    StringToFile(DecodeBase64(aGroups[ListIndexNameToAGroupIndex(FiltForm_Groups.ItemIndex)*3+INDEX_ICON]),sPath);
  end;
end;

procedure EditCommentOnChange(sender:TObject);begin OnChange();end;

procedure InitActions(path:string);
var s,s1:string;
    a:TStringList;
    i,iNeexistuje:Integer;
    bmpIco:TBitmap;
begin
  FiltEdit_Actions.Clear();
  FiltEdit_EditComment.Text:='';
  FiltEdit_ActionsChange.Checked:=false;
  bmpIco:=Base64ToBitmap(ICON_TOOL); //implicitni ikona
  FiltEdit_Ikona.Glyph:=bmpIco;
  bmpIco.Free();
  FiltEdit_ActionsName.Caption:='';
  s:=trim(FileToString(path));
  a:=StrToList(s);
  for i:=0 to a.Count-1 do begin
    s:=a[i];
    s1:=fetch(s,'=');
    case s1 of
      'Name': FiltEdit_ActionsName.Caption:=s;
      'Icon': begin
                bmpIco:=Base64ToBitmap(s);
                FiltEdit_Ikona.Glyph:=bmpIco;
                bmpIco.Free();
              end;  
      'Comment': FiltEdit_EditComment.Text:=s;
      '[Group]':; //ignorujeme
      else begin
        IsFileOk(a[i],FiltEdit_ActionsName.Caption,false,iNeexistuje);
        if(iNeexistuje=1) then a[i]:=WARN_FLAG+a[i]; //priznak varovani
        if(iNeexistuje=2) then a[i]:=ERR_FLAG+a[i]; //pridame priznak chyby
        FiltEdit_Actions.Items.Add(a[i]);
      end;
    end;
  end;
  a.Free();
  //vybereme prvni platnou akci
  if(FiltEdit_Actions.Items.Count>0) then FiltEdit_Actions.ItemIndex:=0;
  sAktAction:='';
  ActionsOnCLick(nil);
  OnNoChange();
end;

procedure InitEdit;
begin

  InitColors(); //nacteme barvy pro zobrazeni
  //zmenit rozmery dialogu
  FiltEdit.Height:=FiltEdit_Cancel.top+FiltEdit_Cancel.height+34;
  FiltEdit.Width:=FiltEdit_Cancel.left+FiltEdit_Cancel.width+17;
  
  FiltEdit_Actions.OnDrawItem:=@Actions_DrawItem; //vlastni obluha kresleni seznamu
  FiltEdit.OnClose:=@FormOnClose; //uspesne ukonceni dialogu
  FiltEdit_Actions.OnClick:=@ActionsOnClick;
  FiltEdit_Actions.OnDblClick:=@ActionsOnDblClick;
  FiltEdit_Cancel.OnClick:=@CancelOnClick;
  //obsluha editacnich tlacitek
  FiltEdit_FilterAdd.OnClick:=@FilterAddOnClick;
  FiltEdit_ListAdd.OnClick:=@ListAddOnClick;
  FiltEdit_GgpAdd.OnClick:=@GgpAddOnClick;
  FiltEdit_GgeAdd.OnClick:=@GgeAddOnClick;
  FiltEdit_ExeAdd.OnClick:=@ExeAddOnClick;
  FiltEdit_BatAdd.OnClick:=@BatAddOnClick;
  FiltEdit_CmdAdd.OnClick:=@CmdAddOnClick;
  FiltEdit_ActionUp.OnClick:=@ActionUpOnClick;
  FiltEdit_ActionDown.OnClick:=@ActionDownOnClick;
  FiltEdit_SetAddSub.OnClick:=@SetAddSubOnClick;
  FiltEdit_Test.OnClick:=@TestOnClick;
  FiltEdit_ActionDel.OnClick:=@ActionDelOnClick;
  FiltEdit_ActionComment.OnClick:=@ActionCommentOnClick;
  FiltEdit_Ikona.OnClick:=@IkonaOnClick;
  FiltEdit_SaveBmp.OnClick:=@SaveBmpOnClick;
  FiltEdit_Save.OnClick:=@SaveOnClick;
  FiltEdit_EditComment.OnChange:=@EditCommentOnChange;
  
  InitParamCmd();
end;

procedure FreeEdit;
begin
  FreeParamCmd();
end;
