// obsluha zalozky pro spravu davek a ggs dialogu
//---------------------- obsluha GGS dialogu ----------------------------
procedure SetEnableItemsGgs;
begin
  FiltGgs_GgsButDir.Enabled:=FiltGgs_GgsJinam.Checked;
end;

procedure GgsPlochaOnClick(sender:TObject);
begin
  SetEnableItemsGgs;
end;

procedure GgsStartOnClick(sender:TObject);
begin
  SetEnableItemsGgs;
end;

procedure GgsJineOnClick(sender:TObject);
begin
  SetEnableItemsGgs;
end;

procedure GgsButDirOnClick(sender:TObject);
var sPath:string;
begin
  //dialog pro nacteni adresare
  sPath:=SelectDir({FiltGgs_GgsDir.Text}'C:\Documents and Settings','Where to save the shortcut');
  if(sPath<>'') then FiltGgs_GgsDir.Text:=sPath;
end;

procedure DlgGgsInit(cmd:string); //inicializace hodnot dialogu podle stringu
var s,sPath:string;               // v prikazech davky
begin
  FiltGgs_EndStop.Checked:=(StrToInt(SeparateLeft(cmd,'|'))=1);
  sPath:=SeparateRight(cmd,'|');
  s:=RegexReplace('^.*\\',sPath,'',true);  //nechame jen posledni adresar
  if((s='0') or (sPath='')) then FiltGgs_GgsPlocha.Checked:=true//plocha v ceskych nebo anglickych win
  else if(s='1') then FiltGgs_GgsStart.Checked:=true
  else begin
    FiltGgs_GgsJinam.Checked:=true;
    FiltGgs_GgsDir.Text:=sPath;
  end;
  SetEnableItemsGgs;
end;

function LnkFromDlg:string;
begin
  if(FiltGgs_EndStop.Checked) then Result:='1|'
  else Result:='0|';
  if(FiltGgs_GgsPlocha.Checked) then Result:=Result+'0'
  else if(FiltGgs_GgsStart.Checked) then Result:=Result+'1'
  else Result:=Result+FiltGgs_GgsDir.Text;
end;

procedure CreateGgs(group:string;bExit:boolean); //vytvori ggs makro pro spusteni davky 'group' pri startu geogetu
var sMakro,APO,sPath,sB:string;
 //i:integer;
begin
  //zastupce pro spusteni GG musi obsahovat: geoget.exe -s=.\load.ggs.pas
  APO:=Chr(39);
  if(bExit) then sB:='true' else sB:='false';
  sMakro:='// '+_('INFO: it is generate automaticaly from Combine plugin ')+
        GetCombineVersion()+CRLF
        +'//'+CRLF
        +'//'+CRLF
        //+'uses CombineFormWait;'+CRLF+CRLF
        +'{$include ..\Combine.lib.pas}'+CRLF+CRLF
        +'function StartupRun:boolean;'+CRLF   //vraci true=ukoncit GG, false=GG pokracuje
        +'begin'+CRLF
        +'  CombineLibInit(); RunGroup('+APO+group+APO+'); CombineLibFree();'+CRLF
        +'  Result:='+sB+';'+CRLF
        +'end;'+CRLF
        ;
  sPath:=GetPathnameFromMacroname(group,'ggs.pas');
  StringToFile(sMakro,sPath);
  //ted vytvorit zastupce (ke stavajicimu jen pridat) a do nej pridat parametr
  //pro spusteni tohoto makra (pozor, pokud jiz existuje mezi parametry
  //toto makro, nepridavat!!!)
end;

function GetLnkPar:string; //nacte parametry zastupce z prikazu davky
var i:integer;
    s:string;
begin
  Result:='GGS=0|'+_('Desktop'); //implicitne ulozit na plochu a neukoncovat geoget
  //Result:='0|Start'; //implicitne ulozit do nabidky Start/Programy/Geoget a neukoncovat geoget
  for i:=0 to FiltForm_Groups.Items.Count-1 do begin
    s:=FiltForm_Groups.Items[i];
    if(copy(s,1,4)='GGS=') then Result:=s;
  end;
  Result:=copy(Result,4,Length(Result)); //preskocit pocatecni 4 znaky
end;

procedure SaveGgs; //vytvori ggs a lnk pro GG, aby pri startu spustil vytvorene ggs
var s,vbsPath,lnkPath,grpPath,dataPath,name:string;
begin
  DlgGgsInit(sAktGgs);
  dataPath:=GeoGet_Datadir;
  lnkPath:=FiltGgs_GgsDir.Text;
  if(copy(lnkPath,length(lnkPath),1)<>'\') then lnkPath:=lnkPath+'\';
  name:=FilenameFromText(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex]+'.lnk');
  grpPath:=GetPathnameFromMacroname(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex],'ggs.pas');
  //nastavime spravne cestu pro zastupce
  s:='Set oWS=WScript.CreateObject("WScript.Shell")'+CRLF;
  if(FiltGgs_GgsPlocha.Checked) then s:=s+'sLinkFile=oWS.SpecialFolders.Item("Desktop") & "\'+name+'"'+CRLF
  else if(FiltGgs_GgsStart.Checked) then s:=s+'sLinkFile=oWS.SpecialFolders.Item("StartMenu") & "\'+name+'"'+CRLF
  else if(FiltGgs_GgsJinam.Checked) then s:=s+'sLinkFile="'+lnkPath+name+'"'+CRLF
  ;
  //vytvorit vbs script pro vytvoreni zastupce, vytvorit zastupce a pak vbs smazat
  s:=s+'Set oLink=oWS.CreateShortcut(sLinkFile)'+CRLF+CRLF
    +'oLink.TargetPath="'+GeoGet_Progpath+'geoget.exe"'+CRLF
    +'oLink.Arguments="-d=""'+dataPath+'"" -s=""'+grpPath+'"""'+CRLF
    +'oLink.Description="GeoGet - '+('prior executes batch: ')+FiltForm_Groups.Items[FiltForm_Groups.ItemIndex]+'"'+CRLF
    +'oLink.HotKey=""'+CRLF
    +'oLink.IconLocation="'+GeoGet_Progpath+'geoget.exe, 0"'+CRLF
    +'oLink.WindowStyle="1"'+CRLF
    +'oLink.WorkingDirectory="'+dataPath+'"'+CRLF
    +'oLink.Save';
  vbsPath:=GetCombineDir+'CreateLnk.vbs';
  //showMessage('XXXX vbsPath='+vbsPath);
  if(FileExists(vbsPath)) then DeleteFiles(vbsPath);
  if(FileExists(lnkPath)) then DeleteFiles(lnkPath);
  StringToFile(s,vbsPath);
  RunShell(vbsPath);  //runshell spousti aplikaci spojenou s *.vbs priponou bez
                      //cekani na dokonceni, proto neni mozne soubor vymazat
                      //(a RunExecem nejde spustit jen zadanim souboru s *.vbs)
                      //mozna RunExec('cd.exe *.vbs'), to jesm nezkousel
  //vytvorime ggs
  s:=FiltForm_Groups.Items[FiltForm_Groups.ItemIndex];
  CreateGgs(s,FiltGgs_EndStop.Checked);
end;

procedure ButGgsOnClick(sender:TObject);
var i:integer;
  ini:TIniFile;
  sPath:string;
begin
  if(FiltForm_Groups.ItemIndex>-1) then begin
    DlgGgsInit(sAktGgs);                           //rozebrat a predat do dialogu
    i:=FiltGgs.ShowModal();
    if(i<>1) then exit; //prerusime
    sPath:=GetPathnameFromMacroname(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex],'ini');
    ini:=TIniFile.Create(sPath);
    sAktGgs:=LnkFromDlg();
    ini.WriteString('Group','GGS',sAktGgs);
    ini.Free();
    SaveGgs();
  end;
end;
//---------------------------------------------
procedure Groups_DrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte {podle dokumentace je typu TOwnerDrawState, ale v enginu je byte});
var
  Bitmap:TBitmap;
  RectSrc,RectTrg:TRect;
  x,y:integer;
begin
  with FiltForm_Groups.Canvas do begin
    Bitmap:=Base64ToBitmap(aGroups[ListIndexNameToAGroupIndex(Index)*3+INDEX_ICON]);
    Brush.Color:=STYLE_BKGCOLOR_FOCUSED;
    if((State AND 1)=1) then begin
      Brush.Color:=STYLE_BKGCOLOR_SELECTED;
      Font.Color:=STYLE_COLOR_SELECTED;
    end;
    FillRect(Rect);
    x:=16; y:=16;
    if(Bitmap<>nil) then begin
      RectSrc.Left:=0; RectSrc.Top:=0;
      RectSrc.Right:=Bitmap.Width; RectSrc.Bottom:=Bitmap.Height;
      RectTrg.Left:=Rect.Left+2; RectTrg.Top:=Rect.Top+2;
      RectTrg.Right:=Rect.Left+2+Bitmap.Width; RectTrg.Bottom:=Rect.Top+2+Bitmap.Height;
      // zkopirovat bitmapu do Canvasu, barva v levem spodnim rohu je pruhledna
      BrushCopy(RectTrg,Bitmap,RectSrc,Bitmap.Canvas.Pixels[0,Bitmap.Height-1]);
      x:=Bitmap.Width;
      y:=Bitmap.Height;
    end;
    TextOut(Rect.Left+(x+6),Rect.Top+2,FiltForm_Groups.Items[Index]);
    if(Bitmap<>nil) then Bitmap.Free();
  end;
end;

procedure ReadGroups;
var list:TStringList;
    sIcon,sName,sComment:string;
    i:Integer;
    ini:TIniFile;
begin
  if(aGroups=nil) then aGroups:=TStringList.Create()
  else aGroups.Clear();
  FiltForm_Groups.Items.Clear();
  list:=TStringList.Create();
  FileList(GetBatchesDir(),list); //seznam souboru v adresari s davkama
  //ShowMessage('TTTTT pocet davkovych soubboru: '+IntToStr(list.Count)+CRLF+list[0]);
  //pro kazdy soubor nacteme jmeno a ikonu do seznamu
  for i:=0 to list.Count-1 do begin
    //uvazujeme jen soubory, ktere konci na '.ini' (v adresari jsou i *.pas)
    if(copy(list[i],length(list[i])-3,4)='.ini') then begin
      ini:=TIniFile.Create(list[i]);
      try
        sName:=ini.ReadString('Group','Name','No name');
        sIcon:=ini.ReadString('Group','Icon','');
        sComment:=ini.ReadString('Group','Comment','');
      finally ini.Free();
      end;
      if(sIcon='') then sIcon:=ICON_TOOL;
      //if(sName='aaa') or (sName='pp2') then StringToFile(sIcon,GetCombineDir()+sName+'.txt');
      aGroups.Add(sName);
      aGroups.Add(sIcon);
      aGroups.Add(sComment);
      FiltForm_Groups.Items.Add(sName);
    end;
  end;
  list.Free();
end;
//---------------------- funkce pro soubory s makrem (toolbar, pluginmanager)

//testuje existenci makra v Batches adresari pro spousteni davky 'name'
//vraci 0-neni nikde,
//      bit 1 - je jako soubor na disku
//      bit 2 - je v pltool
//      bit 3 - je v plgroup
function GetMakroExistsFlags(name,typ:string):integer;
var sPath:string;
begin
  Result:=0;
  sPath:=GetPathnameFromMacroname(name,typ);
  if(FileExists(sPath)) then Result:=Result+IS_MAKRO_FILE;
  if(FileExists(sPath)) then Result:=Result+IS_MAKRO_PLGROUP;
  if(GeoGetToolbar(sPath)) then Result:=Result+IS_MAKRO_PLTOOL;
end;

//obslouzi pripadnou existenci makra 'name' a vrati true, pokud je mozne makro
//prejmenovat (po obsluze neni soubor ani zadny zaznam v pltool nebo v plgroup
//ani neexistuje soubor s makrem)
function ServeIfMakroExist(name,typ:string):boolean;
var i,j:integer;
  s,sPath:string;
begin
  Result:=false;
  i:=GetMakroExistsFlags(name,typ); //zjistime, kde je makro ulozeno
  s:=_('Handling the batch is not possible because ')+CRLF;
  if((i and IS_MAKRO_FILE)>0) then
    s:=s+_('- *.pas file for calling the batch exist')+CRLF;
  if( ((i and IS_MAKRO_PLTOOL)>0) or  ((i and IS_MAKRO_PLGROUP)>0) ) then
    s:=s+_('- icon in toolbar exists or batch is in the plugin manager')+CRLF;
  s:=s+CRLF+_('Delete the file');
  if( ((i and IS_MAKRO_PLTOOL)>0) or  ((i and IS_MAKRO_PLGROUP)>0) ) then
    s:=s+_(' and remove information from plugin manager');
  s:=s+'?';
  if(i>0) then begin
    j:=MessBox(s, 'Rename / delete the batch', 4 {tj. Ano/ne});
    if(j=6) then begin//odpoved je Ano
      sPath:=GetPathnameFromMacroname(name,typ);
      if((i and IS_MAKRO_FILE)>0) then DeleteFile(sPath);
      if((i and IS_MAKRO_PLTOOL)>0) then GeoSetToolbar(sPath,false);
      //z managera se odstrani reloadem pluginu, neni treba odstranovat
      //if((i and IS_MAKRO_PLGROUP)>0) then ;
      GeoReloadPlugins();   //promitneme zmeny na toolbaru a v pluginmanageru
      OnChange();
      ShowMessage(_('Batch was removed from toolbar and plugin manager,')+CRLF
        +_('file *.pas for calling the batch was removed.'));
      Result:=true;
    end;
  end
  else Result:=true;
end;

procedure CreateGgp(group:string); //vytvori ggp makro pro spusteni davky 'group'
var sMakro,APO,sPath,sBmp,sTool:string;
  cIni:TIniFile;
begin
  APO:=Chr(39);
  //nacteme ikonu
  cIni:=TIniFile.Create(GetPathnameFromMacroname(group,'ini'));
  sBmp:=cIni.ReadString('Group','Icon',ICON_TOOL);
  cIni.Free();
  sTool:=ReplaceString(TOOL_TEXT,'%GRP_NAME%',group);   //nahradit jmenem
  sMakro:='// plugin add button for running then batch to toolbar'+CRLF
        +'//'+CRLF
        +'// INFO: it is generate automaticaly from Combine plugin '+
        GetCombineVersion()+CRLF
        +'//'+CRLF
        +'//'+CRLF
        +'{$include ..\Combine.lib.pas}'+CRLF+CRLF
        +'const GROUP_NAME='+APO+group+APO+';'+CRLF
        +CRLF
        +'function PluginCaption: string; begin Result:='+APO+sTool+APO+'; end;'+CRLF+CRLF
        +'function PluginHint: string; begin Result:='''+_('Batch for Combine')+'''; end;'+CRLF+CRLF
        +'function PluginIcon: string; begin Result:=DecodeBase64('+APO+sBmp+APO+'); end;'+CRLF
        +CRLF+CRLF
        +'function PluginFlags: string; begin Result:='+APO+'notrans'+APO+'; end;'+CRLF+CRLF
        +'procedure PluginStart;'+CRLF
        +'begin'+CRLF
        +'  CombineLibInit(); RunGroup(GROUP_NAME); CombineLibFree();'+CRLF
        +'end;'+CRLF
        ;
  sPath:=GetPathnameFromMacroname(group,'ggp.pas');
  StringToFile(sMakro,sPath);
end;

//-------------------------- dialogove funkce
procedure EnableButtonsGroups;
var i:Integer;
begin
  i:=FiltForm_Groups.ItemIndex;
  FiltForm_ButRename.Enabled:=(i>-1);
  FiltForm_ButCopy.Enabled:=(i>-1);
  FiltForm_ButDel.Enabled:=(i>-1);
  FiltForm_ButEdit.Enabled:=(i>-1);
  FiltForm_ButManager.Enabled:=(i>-1);
  FiltForm_ButToolbar.Enabled:=(i>-1);
  FiltForm_ButGgs.Enabled:=(i>-1);
  FiltForm_ButRun.Enabled:=(i>-1);
  FiltForm_ButDebug.Enabled:=(i>-1);
  //tlacitka pro PluginManager a Toolbar
  if(i=-1) then FiltForm_ButToolbar.Enabled:=false
  else FiltForm_ButToolbar.Enabled:=
    ((GetMakroExistsFlags(FiltForm_Groups.Items[i],'ggp.pas') and IS_MAKRO_PLTOOL)=0);
  if(i=-1) then FiltForm_ButManager.Enabled:=false
  else FiltForm_ButManager.Enabled:=
    ((GetMakroExistsFlags(FiltForm_Groups.Items[i],'ggp.pas') and IS_MAKRO_PLGROUP)=0);
end;

procedure GroupsOnClick(sender:TObject);
var ini:TIniFile;
begin // prepiseme komentar
  if(FiltForm_Groups.ItemIndex>-1) then begin
    FiltForm_Comment.Caption:=aGroups[ListIndexNameToAGroupIndex(FiltForm_Groups.ItemIndex)*3+INDEX_COMMENT];
    ini:=TIniFile.Create(GetPathnameFromMacroname(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex],'ini'));
    sAktGgs:=ini.ReadString('Group','GGS','');
    ini.Free();
  end
  else begin sAktGgs:=''; FiltForm_Comment.Caption:=''; end;
  //zjistime GGS prikaz davky
  EnableButtonsGroups();
end;

function IsValidName(name:string):boolean;
var sPath:string;
begin
  sPath:=GetPathnameFromMacroname(name,'ini');
  Result:=false;
  if(FileExists(sPath)) or (name='') then
    ShowError(_('Batch is not possible to create,')+CRLF
      +_(' a file with this name already exists.'))
  else Result:=true;
end;

procedure ButRenameOnClick(sender:TObject);
var s:string;
  i,iGroup:integer;
  cIni:TIniFile;
begin
  i:=-1;
  iGroup:=FiltForm_Groups.ItemIndex;
  FiltName_NewName.Text:=FiltForm_Groups.Items[iGroup];
  while i=-1 do begin
    if(FiltName.ShowModal()=1) then begin //2 se vraci pri preruseni, 1 vraci moje tlacitko OK
      //zkontrolujeme, zda jmeno jiz neexistuje
      if(IsValidName(FiltName_NewName.Text)) then begin
        //zkontrolujeme, zda je mozne prejmenovat
        if((ServeIfMakroExist(FiltForm_Groups.Items[iGroup],'ggp.pas'))) then begin
          s:=GetPathnameFromMacroname(FiltName_NewName.Text,'ini')
          RenameFile(GetPathnameFromMacroname(FiltForm_Groups.Items[iGroup],'ini'),s);
          cIni:=TIniFile.Create(s);
          cIni.WriteString('Group','Name',FiltName_NewName.Text);
          cIni.Free();
        end;
        ReadGroups();
        //vybereme prejmenovanou davku
        for i:=0 to FiltForm_Groups.Items.Count-1 do begin
          if(FiltForm_Groups.Items[i]=FiltName_NewName.Text) then FiltForm_Groups.ItemIndex:=i;
        end;
      end;
    end
    else i:=1; //preruseno uzivatelem
  end;
  GroupsOnClick(nil);
end;

procedure ButCopyOnClick(sender:TObject);
var b:boolean;
    s,sPath:string;
    cIni:TIniFile;
    i:Integer;
begin
  //rekneme si o nove jmeno, zkontrolujeme, zda jiz existuje odpovidajici soubor
  //a pokud ne, vytvorime kopii aktualniho souboru se zmenenou polozkou Name
  FiltName_NewName.Text:='';
  b:=false;
  while (b=false) do begin
    if(FiltName.ShowModal()=1) then begin
      if(IsValidName(FiltName_NewName.Text)) then begin
        sPath:=GetPathnameFromMacroname(FiltName_NewName.Text,'ini');
        s:=FiltForm_Groups.Items[FiltForm_Groups.ItemIndex];
        CopyFile(GetPathnameFromMacroname(s,'ini'),sPath);
        cIni:=TIniFile.Create(sPath);
        cIni.WriteString('Group','Name',FiltName_NewName.Text);
        cIni.Free();
        b:=true;
        ReadGroups();
        //najdeme novou davku a vybereme ji
        for i:=0 to FiltForm_Groups.Items.Count-1 do begin
          //if(s=FiltForm_Groups.Items[i]) then FiltForm_Groups.ItemIndex:=i;
          if(FiltName_NewName.Text=FiltForm_Groups.Items[i]) then begin
            FiltForm_Groups.ItemIndex:=i;
            break;
          end
        end;
        GroupsOnClick(nil);
      end;
    end
    else b:=true;
  end;
end;

procedure ButAddOnClick(sender:TObject);
var b:boolean;
    s,sPath:string;
    i:Integer;
begin
  //rekneme si o nove jmeno, zkontrolujeme, zda jiz existuje odpovidajici soubor
  //a pokud ne, vytvorime pro nej prazdny INI
  FiltName_NewName.Text:='';
  b:=false;
  while (b=false) do begin
    if(FiltName.ShowModal()=1) then begin
      if(IsValidName(FiltName_NewName.Text)) then begin
        sPath:=GetPathnameFromMacroname(FiltName_NewName.Text,'ini');
        s:='[Group]'+CRLF
          +'Name='+FiltName_NewName.Text+CRLF
          +'Comment='+CRLF
          +'Icon='+ICON_TOOL+CRLF;
        StringToFile(s,sPath);
        b:=true;
        ReadGroups();
        //najdeme puvodni davku a vybereme ji
        for i:=0 to FiltForm_Groups.Items.Count-1 do begin
          if(FiltName_NewName.Text=FiltForm_Groups.Items[i]) then FiltForm_Groups.ItemIndex:=i;
        end;
        GroupsOnClick(nil);
      end;
    end
    else b:=true;
  end;
end;


procedure ButDelOnClick(sender:TObject);
  //nechame si potvrdit vymazani a vymazeme soubor i pripadny zaznam v toolbaru
  //a spravci pluginu a Ggs
var i:integer;
begin
  i:=FiltForm_Groups.ItemIndex;
  if(i<>-1) then begin
    if(6<>MessBox('Really clear batch "'+FiltForm_Groups.Items[i]+'"?',
      'Confirm delete the batch',4)) then i:=-1;
  end;
  if(i<>-1) then begin
    //zkontrolujeme, zda neni davka v Pltool nebo Plgroup
    if(ServeIfMakroExist(FiltForm_Groups.Items[i],'ggp.pas')) then begin
      //vymazeme jeji ini
      DeleteFile(GetPathnameFromMacroname(FiltForm_Groups.Items[i],'ini'));
    end;
    ReadGroups();
    if(i>=FiltForm_Groups.Items.Count-1) then i:=FiltForm_Groups.Items.Count-1;
    FiltForm_Groups.ItemIndex:=i;
    //!!!! vymazat i pripadne GGS makro!!!!
    //ShowMessage('WARN: Jeste neni udelane vymazani davky z GGS, tedy jako lnk');
    GroupsOnClick(nil);
  end;
end;

procedure ButEditOnClick(sender:TObject);
begin
  //prepneme zalozku na pro editaci, vyvolame jeji inicializaci aktualni davkou
  InitActions(GetBatchesDir()
    +FilenameFromText(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex])+'.ini');
  FiltEdit.ShowModal();
  GroupsOnClick(nil); //pro pripadnou zmenu v komentari
end;

procedure ButManagerOnClick(sender:TObject);
var sPath:string;
begin
  //pokud jeste neni ve spravci pluginu, vytvorime ggp a pridame ho do spravce
  if(FiltForm_Groups.ItemIndex<>-1) then begin
    CreateGgp(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex]);
    sPath:=GetPathnameFromMacroname(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex],'ggp.pas');
    if(FileExists(sPath)) then GeoSetPluginGroup(sPath,CMD_GROUP_NAME);
    GeoReloadPlugins();  //aktualizujeme seznam pluginu a toolbar
    EnableButtonsGroups();
  end;
end;

procedure ButDelManagerOnClick(sender:TObject);
var sPath:string;
begin
  //pokud jeste neni ve spravci pluginu, vytvorime ggp a pridame ho do spravce
  if(FiltForm_Groups.ItemIndex<>-1) then begin
    sPath:=GetPathnameFromMacroname(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex],'ggp.pas');
    GeoSetToolbar(sPath,false);
    DeleteFile(sPath);
    GeoReloadPlugins();  //aktualizujeme seznam pluginu a toolbar
    EnableButtonsGroups();
  end;
end;

procedure ButToolbarOnClick(sender:TObject);
var sPath:string;
begin
  //zkontrolujeme, zda je ve spravci pluginu a zda existuje ggp,
  //vytvorime ggp a pridame jej do spravce i toolbaru
  if(FiltForm_Groups.ItemIndex>-1) then begin
    CreateGgp(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex]);
    sPath:=GetPathnameFromMacroname(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex],'ggp.pas');
    if(not GeoGetToolbar(sPath)) then GeoSetToolbar(sPath,true);
    ButManagerOnClick(nil); //a pokud je treba, zapiseme i do plgroup a aktualizuje toolbar
  end;
end;

procedure ButRunOnClick(sender:TObject);
begin
  //vlastni provadeni davky musi byt mimo formular, aby byl pristupny
  //busy dialog. Proto tlacitko pro spusteni jen nastavi navratovou hodnotu
  //na 88 a ukonci dialog. Volajici se pak postara o spusteni a vykonani
  //davky a pak o opetovne zobrazeni formulare.
  {
  bDebug:=false;
  if(FiltForm_Groups.ItemIndex>-1) then begin
    //SetFocusBusy(); //najdeme hlavni okno GG a zmenime na nej focus
    FiltForm.Hide();
    RunGroup(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex]);
    FiltForm.Show();
    FiltForm.SetFocus();
  end;
  }
end;

procedure ButDebugOnClick(sender:TObject);
begin
  //spusti davku tak, ze se pred kazdym prikazem opta na pokracovani
  bDebug:=true;
  if(FiltForm_Groups.ItemIndex<>-1) then begin
    FiltForm.Hide();
    RunGroup(FiltForm_Groups.Items[FiltForm_Groups.ItemIndex]);
    FiltForm.Show();
  end;
  bDebug:=false;
end;

//----------- ostatni dialogy -------------
//----------------------------- FiltParam --------------------------------------
procedure ParamFileOnClick(sender:TObject);
var sPath:string;
begin
  if(OpenDlg(_('Add file to parametrers'), //title
              Geoget_Datadir,               //InitDir
              'ofFileMustExist,ofHideReadOnly,ofNoChangeDir', //options
              _('All files')+' (*.*)|*.*',   //filtr
              sPath)) then
  begin
    if(Pos(' ',sPath)<>0) then sPath:='"'+sPath+'"';
    if(length(FiltParam_Param.Text)>0) then sPath:=' '+sPath;
    FiltParam_Param.Text:=FiltParam_Param.Text+sPath;
  end;
end;

procedure ParamDirOnClick(sender:TObject);
var sPath:string;
begin
  sPath:=SelectDir(Geoget_Datadir,_('Add directory to parameters'));
  if(sPath<>'') then
  begin
    if(Pos(' ',sPath)<>0) then sPath:='"'+sPath+'"';
    if(length(FiltParam_Param.Text)>0) then sPath:=' '+sPath;
    FiltParam_Param.Text:=FiltParam_Param.Text+sPath;
  end;
end;
//-----------------------------------------
procedure FreeGroups;
begin
  if(aGroups<>nil) then aGroups.Free();
end;

procedure InitGroups;
begin
  ReadGroups();
  FiltForm_Groups.OnDrawItem:=@Groups_DrawItem;
  
  FiltForm_ButRename.OnClick:=@ButRenameOnClick;
  FiltForm_ButCopy.OnClick:=@ButCopyOnClick;
  FiltForm_ButDel.OnClick:=@ButDelOnClick;
  FiltForm_ButEdit.OnClick:=@ButEditOnClick;
  FiltForm_ButGgs.OnClick:=@ButGgsOnClick;
  FiltForm_ButManager.OnClick:=@ButManagerOnClick;
  FiltForm_ButDelManager.OnClick:=@ButDelManagerOnClick;
  FiltForm_ButToolbar.OnClick:=@ButToolbarOnClick;
  FiltForm_ButAdd.OnClick:=@ButAddOnClick;
  FiltForm_ButRun.OnClick:=@ButRunOnClick;
  FiltForm_ButDebug.OnClick:=@ButDebugOnClick;

  FiltForm_Groups.OnClick:=@GroupsOnClick;
  FiltForm_Groups.OnDblClick:=@ButEditOnClick;
  if(aGroups.Count>0) then FiltForm_Groups.ItemIndex:=0;
  GroupsOnClick(nil);
  
  //--- dialog pro nastaveni parametru pro spusteni
  FiltParam_File.OnClick:=@ParamFileOnClick;
  FiltParam_Dir.OnClick:=@ParamDirOnClick;

  //--- dialog pro nastaveni parametru pro GGS
  FiltGgs_GgsPlocha.OnClick:=@GgsPlochaOnClick;
  FiltGgs_GgsStart.OnClick:=@GgsStartOnClick;
  FiltGgs_GgsJinam.OnClick:=@GgsJineOnClick;
  FiltGgs_GgsButDir.OnClick:=@GgsButDirOnClick;
  {
  ShowMessage('SSSSS jmeno typu okna: '+FiltForm.name+CRLF
    +'titulek okna: '+FiltForm.Caption+CRLF
    +'handle: '+IntToStr(FiltForm.Handle)+CRLF
    //+'parent.name: '+FiltForm.Parent.name+CRLF
    );
  }
end;
