//funkce pro podporu timeru pro odesilani zprav do zobrazeneho okna


{ !!!!!!!!!!!!!!!!!!
  Timer je volan jen pokud GeoGet zpracovava zpravy Windows.
  Pokud spustim ve scriptu jiny program a ceka se na jeho dokonceni (RunExec),
  Timer se vubec nespousti v uvedenem intervalu, ale az po dokonceni spusteneho
  programu.
!!!!!!!!!!!!!!!!! }

type  TTimerParams=record
        iTime,iTimeStep:integer;
        lParam,wParam,iMsg:integer;
        iHandle:longint;
        sTitle,sTitleDis,sPathWnd,sParentTitle,sParentClass:ansistring; //titulek naseho okna a nadrizeneho okna pro
                                    //kontrolu, zda je to opravdu nase spravne okno
        iParentWnd:integer;         //poradi nadrizeneho okna, jehoz titulek mame
                                    //pro kontrolu (-1 = nekontrolovat nadrizene okno)
      end;

var dTimerMessage:TTimer;
    aTimerParams:TTimerParams;

    //externi funkce z dll knihovny pro hledani okna
    //   PChar=PAnsiChar
    function GetParent(hWnd:longint):longint; external 'GetParent@user32.dll stdcall';
    function GetClassNameAnsi(hWnd:longint;sName:PChar;iMaxLen:integer):integer; external 'GetClassNameA@user32.dll stdcall';
    function GetWindowTextAnsi(hWnd:longint;sText:PChar;nChars:integer):integer; external 'GetWindowTextA@user32.dll stdcall';
    function GetWindowTextLengthAnsi(hWnd:longint):integer; external 'GetWindowTextLengthA@user32.dll stdcall';
    function GetWindow(hWnd:longint;iType:integer):longint; external 'GetWindow@user32.dll stdcall';
    function FindWindowExAnsi(hParent,hChild:longint; sClass,sCaption: PChar): longint; external 'FindWindowExA@user32.dll stdcall';
    function GetWindowLongAnsi(hParent:longint; idx:integer): longword; external 'GetWindowLongA@user32.dll stdcall';


procedure TimerMessageStop; //////// tuto funkci je treba zavolat i pri ukonceni davky
begin
{$ifdef DEBUG_HELPER}
LDH('TimerMessageStop()');
{$endif}
  if(dTimerMessage=nil) then exit;
  dTimerMessage.Enabled:=false;
  dTimerMessage.Free();
  dTimerMessage:=nil;
end;

function GetTextFromHandle(hWnd:longint):ansistring;
var n:integer;
begin
  Result:='';
  n:=GetWindowTextLengthAnsi(hWnd)+1;//zjistime delku textu v okne, pricteme 1 na 0x00, ukonceni stringu
  SetLength(Result,n);
  GetWindowTextAnsi(hWnd,Result,n);
  SetLength(Result,n-1);             //nastavime skutecnou delku ve znacich
end;

function FindChildWnd(hParent:longint;sTitle:ansistring; var hChild:longint):integer;
//vraci  Result   hChild
//        1        <>0    nalezeno hledane okno a je pouzitelne
//        -1       <>0    okno nalezeno, ale je disabled nebo neni viditelne
//        0         0     okno nenalezeno
var sCaption,sClass:ansistring;
    wStyle:longword;
    i:integer;
begin
  Result:=0;
  //definice z windows.h
  //    GW_HWNDFIRST = 0          GW_OWNER=4
  //    GW_HWNDLAST = 1           GW_CHILD=5
  //    GW_HWNDNEXT = 2           GW_ENABLEDPOPUP=6
  //    GW_HWNDPREV = 3
  hChild:=GetWindow(hParent,5{=GW_CHILD}); //najdemem prvni dcerine okno
  while (hChild<>0) do begin
    sCaption:=GetTextFromHandle(hChild);   //text okna
    wStyle:=GetWindowLongAnsi(hChild,-16 {=GWL_STYLE});
    SetLength(sClass,100);
    i:=GetClassNameAnsi(hChild,sClass,99);
    SetLength(sClass,i);
    //wStyle:=((wStyleParent) and $10000000);
    {$ifdef DEBUG_HELPER}
      LDH('Dcerine okno: 0x'+DecToHex(hChild,8)
        +', pozadovany: '+sTitle
        +', skutecny: '+sCaption
        +', trida: '+sClass
        +', styl: '+DecToHex((wStyle),8)
        +', visible: '+DecToHex((wStyle and $10000000),8)
        +', disabled: '+DecToHex((wStyle and $08000000),8)
        );
    {$endif}
    //zkontrolujeme, zda je to pozadovany text
    if(sTitle='') then sTitle:='(?i)';
    //if(sCaption=sTitle) then begin
    if(RegexFind(sTitle,sCaption)) then begin
      //zkontrolujeme, je okno viditelne a neni disablovane
      Result:=hChild;
      Result:=1;
      if((wStyle and $10000000)<>$10000000{=WS_VISIBLE}) then Result:=-1; //neni visibled
      if((wStyle and $08000000)=$08000000{=WS_DISABLED}) then Result:=-1; //je disabled
      if(sClass='Static') then Result:=-2; //oknu nejde poslat zpravu
      break;
    end;
    hChild:=GetWindow(hChild,2{=GW_HWNDNEXT});
  end;
end;

function TimerMessageFindWindow:integer;
var hWndMyText,hWndLast,hWndParent:longint;
    wStyle,wStyleParent:longword;
    sAnsi,sMyText:ansistring;
    s:string;
    i:integer;
begin
{$ifdef DEBUG_HELPER}
    LDH('Hledam rodicovske okno (tridy '''+aTimerParams.sParentClass+''') sTitle:'+aTimerParams.sParentTitle);
{$endif}
  Result:=0;
  hWndLast:=0;
  if(aTimerParams.sParentTitle='GEOGET_HWND') then hWndParent:=GEOGET_HWND
  else begin
    hWndParent:=FindWindowExAnsi(0,hWndLast,aTimerParams.sParentClass,aTimerParams.sParentTitle);
    if(hWndParent=0) then begin
      {$ifdef DEBUG_HELPER}
        LDH('Rodicovske okno nenalezeno');
      {$endif}
      exit;
    end;
  end;
  //popis funkce: http://msdn.microsoft.com/en-us/library/windows/desktop/ms633584(v=vs.85).aspx
  //popis stylu:  http://msdn.microsoft.com/en-us/library/windows/desktop/ms632600(v=vs.85).aspx
  wStyleParent:=(GetWindowLongAnsi(hWndParent,-16 {=GWL_STYLE}));
  wStyle:=((wStyleParent) and $10000000);
  {$ifdef DEBUG_HELPER}
    LDH('Rodicovske okno: 0x'+DecToHex(hWndParent,8)
      +', styl: '+DecToHex((wStyleParent),8)
      +', visible: '+DecToHex((wStyle),8)
      +', disabled: '+DecToHex((wStyleParent and $08000000),8)
      );
  {$endif}
  if(wStyle<>$10000000{=WS_VISIBLE}) 
    or ((wStyleParent and $08000000)=$08000000{=WS_DISABLED}) then begin
    {$ifdef DEBUG_HELPER}
        LDH('Rodicovske okno neni viditelne => nenalezeno');
    {$endif}
    exit; //neni visibled
  end;
  //prohledame dcerina okna po cele ceste k cilovemu
  s:=aTimerParams.sPathWnd;
  i:=0;
  while (s<>'') do begin
    sAnsi:=Fetch(s,';');
    {$ifdef DEBUG_HELPER}
      LDH('Hledame na ceste okno s titulkem: '+sAnsi);
    {$endif}
    i:=FindChildWnd(hWndParent,sAnsi,hWndMyText);
    hWndParent:=hWndMyText; //dal pokracujeme dalsim oknem v retezu
    if(i<>1) then exit;     //nenalezeno nebo disabled, konec hledani
  end;
  //prosli jsme uspesne cely retez, ted hledame okno, kteremu poslat zpravu
  sMyText:=aTimerParams.sTitle;
  while (sMyText<>'') do begin
    {$ifdef DEBUG_HELPER}
      LDH('Hledame cilove okno s titulkem: '+sMyText);
    {$endif}
    i:=FindChildWnd(hWndParent,sMyText,hWndMyText);
    {$ifdef DEBUG_HELPER}
      LDH('Navratova hodnota z hledani: '+IntToStr(i));
    {$endif}
    if(i=0) then exit; //nenalezeno
    if(i=1) then break; //posleme mu zpravu
    if(sMyText=aTimerParams.sTitleDis) then exit;
    sMyText:=aTimerParams.sTitleDis;
  end;
  Result:=hWndMyText;
end;

procedure TimerMessageOnTick(Sender:TObject);
begin
{$ifdef DEBUG_HELPER}
LDH('TimetMessageOnTick(): start');
{$endif}
  if(dTimerMessage=nil) then exit;
  //zkusime najit okno
  aTimerParams.iHandle:=TimerMessageFindWindow();
//      {$ifdef DEBUG_HELPER}
//        LDH('Handle hledaneho okna: '+DecToHex(aTimerParams.iHandle,8));
//      {$endif}
  if(aTimerParams.iHandle<=0) then
    aTimerParams.iTime:=aTimerParams.iTime-aTimerParams.iTimeStep //dalsi krok casovace
  else begin  //pokud je okno nalezeno, posleme mu zpravu
    //if(aTimerParams.iHandle=-1) then begin //nalezene okno je skryte/disablovane,
    //  aTimerParams.iTime:=0;               //zpravu mu poslat nejde, ukoncime casovac
    //end
    //else begin
      {$ifdef DEBUG_HELPER}
        LDH('Posilam zpravu nalezenemu oknu');
      {$endif}
      {i:=}PostMessage(aTimerParams.iHandle,aTimerParams.iMsg,aTimerParams.lParam,aTimerParams.wParam);
      aTimerParams.iTime:=0;               //zpravu mu poslat nejde, ukoncime casovac
    //end;
  end;
{$ifdef DEBUG_HELPER}
LDH('TimetMessageOnTick(): zbyvajici cas: iTime='+IntToStr(aTimerParams.iTime)
  +', iTimeStep='+IntToStr(aTimerParams.iTimeStep));
{$endif}
  //pokud vyprsel celkovy cas, ukoncime casovac
  if(aTimerParams.iTime<=0) then TimerMessageStop();
end;

procedure TimerMessageInit(sParams:string);
// v sParams jsou '|' oddelene hodnoty:
//     sParentTitle - titulek rodicovskeho okna
//     ParentClass  - trida rodicovskeho okna nebo '' (pak se prohledavaji vsechna okna)
//     sTitle       - titulek okna, kteremu poslat zpravu
//     sTitleDis    - titulek okna, kteremu poslat zpravu, pokud je "hlavni" okno disabled
//     iTime        - pocet sekund, kolik se celkem muze cekat
//     iTimeStep    - krok v sekundach, jak casto kontrolovat existenci okna
//     sMessage     - typ odesilane zpravy (budto ciselny kod nebo zkratka WM_CLOSE, WM_CLICK, WM_KEYDOWN)
//     wParam       - hodnota prvniho parametru pri posilani zpravy
//     lParam       - hodnota prvniho parametru pri posilani zpravy

var s:string;
    //sAnsi:ansistring;
begin
{$ifdef DEBUG_HELPER}
LDH('TimerMessageInit(), Handle Geogetu='+DecToHex(GEOGET_HWND,6));
{$endif}
  aTimerParams.sParentTitle:='';
  aTimerParams.sParentClass:='';
  aTimerParams.sPathWnd:='';
  aTimerParams.sTitle:='';
  aTimerParams.sTitleDis:='';
  //vypiseme seznam vsech oken
  if(dTimerMessage<>nil) then begin
    ShowMessage(_('ERR: Multiple use TimerSimulate() function. Function not activated.'));
    exit;
  end;
  //prevezmeme parametry pro nalezeni okna, kteremu poslat zpravu
  aTimerParams.sParentTitle:=Fetch(sParams,';');
  aTimerParams.sParentClass:=Fetch(sParams,';');
  s:=Fetch(sParams,'|')+';';
  while (s<>'') do begin
    if(aTimerParams.sPathWnd<>'') then aTimerParams.sPathWnd:=aTimerParams.sPathWnd+';';
    aTimerParams.sPathWnd:=aTimerParams.sPathWnd+aTimerParams.sTitle;
    aTimerParams.sTitle:=aTimerParams.sTitleDis;
    aTimerParams.sTitleDis:=Fetch(s,';');
{$ifdef DEBUG_HELPER}
//LDH('  ParentTitle: '+aTimerParams.sParentTitle
//    +'  ParentClass: '+aTimerParams.sParentClass
//    +'  sPathWnd: '+aTimerParams.sPathWnd
//    +'  sTitle: '+aTimerParams.sTitle
//    +'  sTitleDis: '+aTimerParams.sTitleDis
//    );
{$endif}
  end;
{$ifdef DEBUG_HELPER}
LDH('  ParentTitle: '+aTimerParams.sParentTitle
    +'  ParentClass: '+aTimerParams.sParentClass
    +'  sPathWnd: '+aTimerParams.sPathWnd
    +'  sTitle: '+aTimerParams.sTitle
    +'  sTitleDis: '+aTimerParams.sTitleDis
    );
{$endif}
  
  //parametry casovace
  s:=Fetch(sParams,';'); if(s='') then s:='0';
  aTimerParams.iTime:=1000*StrToInt(s);         //prevedeme na milisekundy
  s:=Fetch(sParams,';'); if(s='') then s:='0';
  aTimerParams.iTimeStep:=1000*StrToInt(s);     //prevedeme na milisekundy

  s:=Fetch(sParams,';');
  case s of    ///http://www.autohotkey.com/docs/misc/SendMessageList.htm
  'WM_CLOSE': aTimerParams.iMsg:=$10;
  'WM_CLICK': aTimerParams.iMsg:=$F5;
  'WM_KEYDOWN': aTimerParams.iMsg:=$100; //wParam=virtual code (http://msdn.microsoft.com/en-us/library/windows/desktop/dd375731(v=vs.85).aspx)
                                         //lParam=shift,alt,ctrl, ... (http://msdn.microsoft.com/en-us/library/windows/desktop/ms646280(v=vs.85).aspx)
  else aTimerParams.iMsg:=StrToInt(s);   //predano primo cislo zpravy
  end;
  s:=Fetch(sParams,';'); if(s='') then s:='0';
  aTimerParams.wParam:=StrToInt(s);
  s:=Fetch(sParams,';'); if(s='') then s:='0';
  aTimerParams.lParam:=StrToInt(s);


  //pokud nedojde k ukonceni timeru, zustane memory leak, ale jaky parent sem mam nastavit?
  dTimerMessage:=TTimer.Create(nil);
  dTimerMessage.Enabled:=false;
  dTimerMessage.Interval:=aTimerParams.iTimeStep;
  dTimerMessage.OnTimer:=@TimerMessageOnTick;
  dTimerMessage.Enabled:=true;
{$ifdef DEBUG_HELPER}
  LDH('  Interval casovace='+IntToStr(dTimerMessage.Interval));
  Sleep(2000);
{$endif}
end;

procedure TimerWaitingToStop(iSec:integer);
begin
  while (dTimerMessage<>nil) and (iSec>0) do begin
{$ifdef DEBUG_HELPER}
LDH('Cekam na ukonceni timeru, jeste '+IntToStr(iSec)+' s');
{$endif}
    Dec(iSec);
    Sleep(990); //v milisekundach, ale neco se spotrebuje na volani, ...
  end;
end;