{$define COMBINE_DLG}

//definice by mela byt zde, aby slo ladeni vyuzit i pro davku volanou z toolbaru
//a ne jen volanou z formulare Combine
{ $define DEBUG_HELPER}
{$ifdef DEBUG_HELPER}
  {$include DebugHelper.lib.pas}
{$endif}


{$include RelToAbsPath.lib.pas} //nelze pouzit jako uses, pak nejde prelozit ggp
{$include StringFunc.lib.pas}   //pro prevod na Hex
{$include Combine.config.pas}
{$include RunShellWait.pas}
{$include Combine.Timer.pas}

const MAX_CMD=200;                        //max prikazu v CMD_FILE souboru
      CombineDir='Combine2';
      VAR_NOEXIST='--Unknown variable--';
      TAG_CLEAR='--Combine-CLEAR--';
      GGT_TEMP_FILENAME='--CombineTemp.ggt';
      ERR_FLAG='ERR:'; //priznak chyby pro podbarveni prikazu s neexistujicim souborem
      WARN_FLAG='WARN:'; //priznak varovani pro podbarveni prikazu s neexistujicim souborem
{$ifdef WINE}   //nastavime promennou jako priznak, ze pracujeme pod wine/linuxem
      bWine=1;
{$else}
      bWine=0;
{$endif}
type TfEventProcedure=procedure(sender:TObject);
     TfRunGroup=procedure(nameGroup:string);

var aReplace:TStringList;
    fRunGroup:TfRunGroup;
    iContinue:Integer;
    bIsbLastTest:boolean;
    bLastTest:boolean;
    sLastRet:string;
    bDebug:boolean;          //priznak ladiciho spusteni
    //dialog pro dalsi zapracovani
    iRunInfo:integer;        //priznak zobrazeni informace o fazi provadeni davky
    dRunInfo:TForm;          //dialog pro informaci o behu
    dInfoKrok:TLabel;        //provadeny krok
    dInfoStart:TLabel;       //start davky
    dInfoBar:TProgressBar;   //graficke zobrazeni uplynuleho casu
    dInfoAbort:TButton;      //nasilne preruseni davky
    bHideImportResults:boolean; //zakaze zobrazeni vysledku importu
    //promenne pro dialog na cekani pred dalsim pokracovanim
    //dWait:TForm;             //dialog pro cekani na preruseni
    //dText:TLabel;            //text zpravy
    //dTime:TLabel;            //text pro zbyvajici sekundy
    //dOk:TButton;             //tlacitko pro pokracovani
    //dBreak:TButton;          //tlacitko pro preruseni
    //dBar:TProgressBar;       //graficke zobrazeni uplynuleho casu
    //iTime:integer;           //pocet zbyvajicich sekund

//funkce z knihovny pro nalezeni okna, zobrazeni okna a zmenu focusu
//function Win32GetParent(hWnd:Longint):integer; external 'GetParent@user32.dll stdcall';
//function Win32FindWindow(C1, C2: PChar): Longint; external 'FindWindowA@user32.dll stdcall';
//function Win32ShowWindow(hWnd: Longint): Integer; external 'SetForegroundWindow@user32.dll stdcall';
//function Win32SetFocus(hWnd:Longint):Longint; external 'SetFocus@user32.dll stdcall';
//function Win32GetWindowText(hWnd:Longint; Text:pChar; len:Longint):integer; external 'GetWindowTextA@user32.dll stdcall';
//function Win32GetClassName(hWnd: Longint; lpClassName:PChar; nMaxCount:Longint):integer; external 'GetClassNameA@user32.dll stdcall';
//procedure Win32Sleep(dwMiliseconds:Longint); external 'Sleep@Kernel32.dll stdcall';

//funkce pro nastaveni promenne prostredi
function Win32SetEnvironmentVariable(sName,sValue:PChar):integer; external 'SetEnvironmentVariableA@Kernel32.dll stdcall';

function GetCombineDir:string;
begin
  Result:=Geoget_Scriptdir+'\'+CombineDir+'\';
end;

function GetScriptDir:string;
begin
  Result:=GetCombineDir()+'Scripts\';
end;

function GetBatchesDir:string;
begin
  Result:=GetCombineDir()+'Batches\';
end;

function GetCombineVersion:string;
begin
  Result:=GeoGetPackageVersion(ReplaceString(GEOGET_SCRIPTFULLNAME,'.ggp.pas','.meta.ini'));
end;

//vraci absolutni cestu k souboru s vytvorenym makrem pro pltool/plgroup
function GetPathnameFromMacroname(name,typ:string):string;
begin
//LDH('YYSS name='+name);
  Result:=GetBatchesDir()+FilenameFromText(name+'.'+typ);
//LDH('YYSS name='+name+CRLF+'FileName='+FilenameFromText(name+'.'+typ));
end;

function GetCmdIniPathname:string;
begin
  Result:=ReplaceString(GEOGET_SCRIPTFULLNAME,'.ggp.pas','Command_'+Uppercase(copy(GetCurrentLanguage(),1,2))+'.ini');
  if(not FileExists(Result)) then   //pokud neni, pouzijeme anglictinu
    Result:=ReplaceString(GEOGET_SCRIPTFULLNAME,'.ggp.pas','Command_EN.ini');
  if(not FileExists(Result)) then begin
    ShowMessage(_('File not found:')+CRLF+Result);
    GeoAbort();
  end;
end;

function StrToList(str:string):TStringList;
//var s:string;
begin
  Result:=TStringList.Create();
  while str<>'' do begin
    Result.Add(Trim(fetch(str,CRLF)));
    //s:=Trim(fetch(str,CRLF));
    //Result.Add(fetch(s,'#'));
  end;
end;

function TrimErrFlag(sCmd:string; var iErrWarnFlag:integer):string;
begin
  Result:=sCmd;
  iErrWarnFlag:=0;
  if(copy(sCmd,1,length(WARN_FLAG))=WARN_FLAG) then begin
    iErrWarnFlag:=1;
    Result:=copy(sCmd,length(WARN_FLAG)+1,length(sCmd));
  end;
  if(copy(sCmd,1,length(ERR_FLAG))=ERR_FLAG) then begin
    iErrWarnFlag:=2;
    Result:=copy(sCmd,length(ERR_FLAG)+1,length(sCmd));
  end;
end;

function GetActionType(row:string):string;
var s:string;
begin
  s:=row;
  Result:=fetch(s,'=');
  if(Result=row) then Result:='ERR';
end;

function GetConditioned(row:string):string;
begin
  Result:=row;
  fetch(Result,'=');
  if(Result='') then Result:=row;
  Result:=copy(Result,1,1);
  if(Result<>'+') and (Result<>'-') then Result:='';
end;

procedure ReplaceAdd(prom,value:string);   //prida promennou do pole pro nahradu
begin
  aReplace.Add(prom);
  aReplace.Add(value);
end;

procedure ReplaceSet(prom,value:string);   //nastavi novou hodnotu promenne
var i,j:Integer;
begin
  j:=-1;
  for i:=0 to aReplace.Count-1 do begin
    if(aReplace[i]=prom) then begin
      j:=i;
      aReplace[i+1]:=value;
      i:=aReplace.Count-1;
    end
    else Inc(i);               //preskocime hodnotu
  end;
  if(j=-1) then ReplaceAdd(prom,value);
end;

procedure ReplaceRemove(prom:string);   //odstrani promennou
var i:Integer;
begin
  for i:=0 to aReplace.Count-1 do begin
    if(aReplace[i]=prom) then begin
      aReplace.Delete(i+1);    //vymazeme hodnotu
      aReplace.Delete(i);      //vymazeme jmeno promenne
      i:=aReplace.Count-1;
    end
    else Inc(i);               //preskocime hodnotu
  end;
end;

procedure DebugShowProm;
var s:string;
    i:Integer;
begin
  s:=_('Number of variables ')+IntToStr(aReplace.Count/2)+CRLF+'---------------------'+CRLF;
  for i:=0 to aReplace.Count-1 do begin
    s:=s+aReplace[i]+' => '+aReplace[i+1]+CRLF;
    i:=i+1;
  end;
  ShowMessage(s);
end;

function GetVarValue(prom:string):string;
var i:Integer;
begin
  Result:=VAR_NOEXIST;
  for i:=0 to aReplace.Count-1 do begin
    if(aReplace[i]=prom) then begin
      Result:=aReplace[i+1];
    end
    else i:=i+1;
  end;
end;

procedure SetVarDateTime; //nastavi datove/casove promenne
var w1,w2,w3,w4:word;
begin
  DecodeDate(Now,w1,w2,w3);
  ReplaceSet('CombineYear',FormatFloat('0000',w1));
  ReplaceSet('CombineMonth',FormatFloat('00',w2));
  ReplaceSet('CombineDay',FormatFloat('00',w3));
  DecodeTime(Now,w1,w2,w3,w4);{milisekundy nepouzivame}
  ReplaceSet('CombineHour',FormatFloat('00',w1));
  ReplaceSet('CombineMin',FormatFloat('00',w2));
  ReplaceSet('CombineSec',FormatFloat('00',w3));
  ReplaceSet('CombineDateTime',FloatToStr(Now())); {aktualni cas v extended formatu}
end;

function ReplaceToProm(text:string):string;
begin //nahradi vsechny cesty do GG adresare za promenne
  Result:=text;
  Result:=RegexReplace('(?i)'+ReplaceString(Geoget_Scriptdir,'\','\\'),Result,'%GG_SCRIPTDIR%',false);
  Result:=RegexReplace('(?i)'+ReplaceString(Geoget_Datadir,'\','\\'),Result,'%GG_DATADIR%',false);
  Result:=RegexReplace('(?i)'+ReplaceString(Geoget_Progpath,'\','\\'),Result,'%GG_PROGDIR%',false);
end;

function ReplaceProm(s:string):string;
var i,j:Integer;
    //s1:string;
begin
  Result:=ReplaceToProm(s);  //nahradit promenne GeoGetu
  j:=((aReplace.Count-1)/2);
{$ifdef DEBUG_HELPER}
//    LDHD('ReplaceProm(): s='+s+', n='+IntToStr(aReplace.Count)+', j='+IntToStr(j),ldhInfo);
{$endif}
  for i:=0 to j do begin //nahradit promenne definovane v davce
{$ifdef DEBUG_HELPER}
//    LDHD('ReplaceProm()-1: aReplace[i*2]='+aReplace[i*2]+', i='+IntToStr(i)+', s='+aReplace[i*2+1],ldhInfo);
{$endif}
    if(pos('%'+aReplace[i*2]+'%',Result)>=1) then begin
      //if(Length(aReplace[i*2+1])<1000) then begin
        Result:=ReplaceString(Result,'%'+aReplace[i*2]+'%',aReplace[i*2+1]);
      //end
      //else}
      //  begin  //ovsem pozor, tohle nedela vsechny vyskyty, ale jen ten prvni
      //            //snad to u tech dlouhych stringu nebude vadit
      //  s1:=FetchBin(Result,'%'+aReplace[i*2]+'%');
      //  Result:=s1+aReplace[i*2+1]+Result;
      //end;
    end;
  end;
  Result:=ExpandEnvir(Result); //nahradime i systemove promenne prostredi
end;

function GetFileDir(bDir:boolean;sPath,sDefaultType:string):string;
var s,sType:string;
begin
  //vstupni parametr obsahuje puvodni adresar/soubor
  Result:=sPath;
  if(sPath='') then s:=Geoget_Datadir else s:=sPath;
  if(bDir) then begin
    s:=SelectDir(s,_('Select the directory for a command parameter'));
    if(s<>'') then Result:=s;
  end
  else begin
    //zkonstruujeme seznam typu souboru
    case sDefaultType of
    'txt': s:='txt,html,exe,ggt,ggp,,gcl,sql,gpx,zip,all';
    'ini': s:='ini,txt,html,exe,ggt,ggp,gcl,sql,gpx,zip,all';
    'ggt': s:='ggt,ggp,gcl,ini,txt,html,exe,sql,gpx,zip,all';
    'html': s:='html,txt,ini,exe,ggt,ggp,gcl,sql,gpx,zip,all';
    'exe': s:='exe,txt,html,ggt,ggp,gcl,sql,gpx,zip,all';
    'ggp': s:='ggp,gcl,txt,html,exe,ggt,sql,gpx,zip,all';
    'gcl': s:='gcl,ggt,ggp,txt,html,exe,sql,gpx,zip,all';
    'sql': s:='sql,txt,gcl,ggt,ggp,html,exe,gpx,zip,all';
    'gpx': s:='gpx,zip,all,sql,txt,gcl,ggt,ggp,html,exe';
    'zip': s:='zip,gpx,all,sql,txt,gcl,ggt,ggp,html,exe';
    'all': s:='all,sql,txt,gcl,ggt,ggp,html,gpx,zip,exe';
    else s:=sDefaultType+',all';
    end;
    sType:='';
    while(s<>'') do begin
      sDefaultType:=Fetch(s,',');
      if(sType<>'') then sType:=sType+'|';
      case sDefaultType of
        'ini': sType:=sType+_('INI files')+' (*.ini)|*.ini';
        'gpx': sType:=sType+_('GPX files')+' (*.gpx)|*.gpx';
        'zip': sType:=sType+_('Zip files')+' (*.zip)|*.zip';
        'txt': sType:=sType+_('Text files')+' (*.txt)|*.txt';
        'ggt': sType:=sType+ _('List files')+' (*.ggt)|*.ggt';
        'html':sType:=sType+_('HTML files')+' (*.html; *.htm)|*.html;*.htm';
        'exe':sType:=sType+_('Executable files')+' (*.exe; *.com; *.bat; *.cmd)|*.exe; *.bat; *.cmd; *.com';
        'ggp':sType:=sType+_('GeoGet scripts')+' (*.pas)|*.pas';
        'gcl':sType:=sType+_('Column''s files')+' (*.gcl)|*.gcl';
        'sql':sType:=sType+_('SQL files')+' (*.sql)|*.sql';
        'all':sType:=sType+_('All files')+' (*.*)|*.*';
      else sType:=sType+sDefaultType+' '+_('files')+' (*.'+sDefaultType+')|*.'+sDefaultType;
      end;
    end;
    s:=sPath;
    if(OpenDlg(_('Select the file for a command parameter'),
               Geoget_Datadir,'',sType,s)) then
      Result:=s;
  end;
end;

//testuje, zda predane jmeno souboru (s pripadnymi parametry) existuje (bez parametru)
//v pripade, ze ne, zobrazi chybu a vraci priznak chyby a plnou cestu
function IsFileOk(sFileParam, sGrp:string; bWarnMsg:boolean; var iNeexistuje:integer):string;
var c,s,sTyp,sFile:string;
begin
  s:=ReplaceProm(sFileParam);
  sTyp:=fetch(s,'=');
  sFile:=SeparateLeft(s,'|');
  iNeexistuje:=0;
  if(sTyp='') then exit;
  //odparat pripadny priznak podmineneho zpracovani
  c:=copy(sFile,1,1);
  if(c='+') or (c='-') then sFile:=copy(sFile,2,length(sFile))
  else c:='';
  if(sTyp<>'CMD') and (sTyp<>'CMT') and (sTyp<>'GGS') then begin
    sFile:=RelToAbsFilename(sFile,GEOGET_DATADIR);//pokud nema zadanou cestu, doplnit DATADIR
    if(not FileExists(sFile)) then begin
      iNeexistuje:=2;
      if(RegexFind('%.*%',sFile)) then iNeexistuje:=1;
      if(iNeexistuje=2) or (bWarnMsg) then
{$ifdef DEBUG_HELPER}
        LDHD('IsFileOk(): nenalezen soubor '+CRLF
          +_('Batch: ')+sGrp+CRLF
          +_('Command: ')+sFileParam+CRLF
          +_('Type: ')+sTyp+CRLF
          +_('File:')+sFile,ldhInfo);
{$endif}
        ShowMessage(_('Batch: ')+sGrp+CRLF
          +_('Command: ')+sFileParam+CRLF
          +_('Type: ')+sTyp+CRLF
          +_('File:')+sFile+CRLF+CRLF
          +_('This file was not found, therefore the batch may not be fully functional.')+CRLF
          +_('If the file will be created by commands of batch, contains variable')+CRLF
          +_('and similarly, is this warning irrelevant.'));
    end;
  end;
  Result:=sTyp+'='+c+sFile+'|'+s;
end;

function GgTypes2Api(sType:string):string;
var i:Integer; //prevede zkratky typu na plne typy tak, jak je zna gc.com
begin
  Result:='';
  if(sType='') then sType:='CEGHILMTUVWY';
  sType:=Uppercase(sType);
  for i:=1 to length(sType) do begin
    case sType[i] of
      'C': Result:=Result+'Cache In Trash Out Event'+CRLF;
      'E': Result:=Result+'Event Cache'+CRLF;
      'G': Result:=Result+'Earthcache'+CRLF;
      'H': Result:=Result+'Letterbox Hybrid'+CRLF;
      'I': Result:=Result+'Wherigo Cache'+CRLF;
      'L': Result:=Result+'Locationless (Reverse) Cache'+CRLF;
      'M': Result:=Result+'Multi-cache'+CRLF;
      //'O': Result:=Result+'Other'+CRLF;
      'T': Result:=Result+'Traditional Cache'+CRLF;
      'U': Result:=Result+'Unknown Cache'+CRLF;
      'V': Result:=Result+'Virtual Cache'+CRLF;
      'W': Result:=Result+'Webcam Cache'+CRLF;
      'Y': Result:=Result+'Lost and Found Event Cache'+CRLF;
    end;
  end;
  Result:=Trim(Result);
end;

function GgSizes2Api(sSize:string):string;
var i:Integer; //prevede zkratky obtiznosti/terenu na cisla tak, jak to pouziva gc.com
begin
  Result:='';
  if(sSize='') then sSize:='MSRLON';
  sSize:=Uppercase(sSize);
  for i:=1 to length(sSize) do begin
    case sSize[i] of
      'M': Result:=Result+'Micro'+CRLF;
      'S': Result:=Result+'Small'+CRLF;
      'R': Result:=Result+'Regular'+CRLF;
      'L': Result:=Result+'Large'+CRLF;
      'O': Result:=Result+'Other'+CRLF;
      'N': Result:=Result+'Not chosen'+CRLF;
    end;
  end;
  Result:=Trim(Result);
end;

function TreeState2GgInt(s:string):integer;
begin
  Result:=2;
  case Uppercase(s) of
    'NO': Result:=0;
    'YES': Result:=1;
  end;
end;

function ReadApiCfg(path:string):TGCLSearch;      //nacist soubor do struktury rApiCfg
var ini:TIniFile;
begin
  Result.cx:=0;        //vynulovat
  Result.cy:=0;
  Result.cr:=0;
  if(not FileExists(path)) then exit;
  ini:=TIniFile.Create(path);
  //Result.cx:=StrToFloat(ini.ReadString('Download','Lon','0'));
  Result.cx:=StrToFloat(ini.ReadString('Download','Lat','0'));
  //Result.cy:=StrToFloat(ini.ReadString('Download','Lat','0'));
  Result.cy:=StrToFloat(ini.ReadString('Download','Lon','0'));
  //ShowMessage('AAAAA 4'+floatToStr(Result.cy));
  Result.cr:=StrToFloat(ini.ReadString('Download','Radius','0'));
  Result.islite:=ini.ReadBool('Download','IsLiteListing',true);
  //ShowMessage('AAAA 5: Lite='+IntToStr(Result.islite as integer));
  Result.cachetypes:=GgTypes2Api(ini.ReadString('Download','CacheTypes',''));
  Result.cachesizes:=GgSizes2Api(ini.ReadString('Download','CacheSizes',''));
  Result.available:=TreeState2GgInt(ini.ReadString('Download','Available','ANY'));
  Result.archived:=TreeState2GgInt(ini.ReadString('Download','Archived','ANY'));
  Result.pmo:=TreeState2GgInt(ini.ReadString('Download','PMO','ANY'));
  Result.ignorelist:=ini.ReadBool('Download','IgnoreList',false);
  Result.notfoundby:=ReplaceString(ReplaceProm(ini.ReadString('Download','NotFoundBy','')),'\n',CRLF);
  Result.hiddenby:=ReplaceString(ReplaceProm(ini.ReadString('Download','HiddenBy','')),'\n',CRLF);
  Result.nothiddenby:=ReplaceString(ReplaceProm(ini.ReadString('Download','NotHiddenBy','')),'\n',CRLF);
  ini.Free();
end;

//------------------- prace s TAGy ---------------------------------------------
procedure TagManipulate(selected,typ,category,value:string); //pokud je value=nil, vymaze, jinak prida hodnotu
var s:string;                          //predpoklada se vstup v ANSI
    aList:TStringList;
    bod:TGeo;
    i:integer;
    b:boolean;
begin
  //ShowMessage('SSSS value='+value+', category='+category);
  s:=Geoget_Datadir+'\'+GGT_TEMP_FILENAME;
  GeoListSave(s);
  aList:=TStringList.Create();
  if(FileExists(s)) then begin
    aList.LoadFromFile(s);
    for i:=0 to aList.Count-1 do begin
      bod:=TGeo.Create(); //pro vypnuti optimalizace musime vzdy vytvaret instanci znovu
      //bod.Gc(aList[i]);
      bod.id:=aList[i]; // podle Gebyho staci jen priradit ID
      if(bod.id<>'') then begin
        b:=true; //pro selected=0 (nebrat ohled na vybranost)
        if((selected='SEL') and (not bod.IsSelected())) then b:=false;
        if((selected='UNSEL') and (bod.IsSelected())) then b:=false;
        if(b) then begin
          case typ of
          'ADD': bod.TagAdd(AnsiToUtf(category),AnsiToUtf(value));
          'DEL': bod.TagDel(AnsiToUtf(category),AnsiToUtf(value));
          'CLEAR': bod.TagClear(AnsiToUtf(category));
          end;
        end;
      end;
      bod.Free();
    end;
  end;
  aList.Free;
  DeleteFiles(s);
end;
//------------------- prace s registry -----------------------------------------
function TestRegistryInput(klic,jmeno,typ,hodnota:string):boolean;
begin
  Result:=true;
end;

function RegKeyStringToInt(str:string):Integer;
begin
  case str of
    'HKEY_CLASSES_ROOT':     Result:=$80000000;
    'HKEY_CURRENT_USER':     Result:=$80000001;
    'HKEY_LOCAL_MACHINE':    Result:=$80000002;
    'HKEY_USERS'         :   Result:=$80000003;
    'HKEY_PERFORMANCE_DATA': Result:=$80000004;
    'HKEY_CURRENT_CONFIG'  : Result:=$80000005;
    'HKEY_DYN_DATA'        : Result:=$80000006;
    'HKCR':                  Result:=$80000000;
    'HKCU':                  Result:=$80000001;
    'HKLM':                  Result:=$80000002;
    'HKU':                   Result:=$80000003;
    'HKPD':                  Result:=$80000004;
    'HKCC':                  Result:=$80000005;
    'HKDD':                  Result:=$80000006;
    else Result:=0;
  end;
end;
//------------------ obsluha API GC.Live --------------------------
function ApiMakeList(str_list:string):TStringList;
  //ziska seznam kesi (ze stringu nebo podle jeho priznaku)
var s,s1,s2,s3,f:string;
  g:TGeo;
  //SEL znamena jen oznacene kese ze seznamu zobrazenych
  //ALL znamena vsechny kese ve zobrazenem seznamu
  //jinak je ve stringu primo ID seznam (oddelovac carka)
begin
  Result:=TStringList.Create(); //seznam bude setrideny a budem ignorovat duplicity
  Result.Sorted:=true;
  Result.Duplicates:=dupIgnore;
  s:=str_list;
  s:=ReplaceString(s,' ','');   //vyhazet vsechny mezery
  s:=ReplaceString(s,',',CRLF); //oddelit kese CRLF
  s:=ReplaceString(s,';',CRLF);
  while(s<>'') do begin
    s1:=fetch(s,CRLF);
    case s1 of
      'SEL','UNSEL': begin
               f:=Geoget_Datadir+'\'+GGT_TEMP_FILENAME;
               GeoListSave(f);
               if(FileExists(f)) then begin
                 //pred pridanim zkontrolujeme kazdou kes, zda je mezi oznacenymi
                 s3:=trim(FileToString(f));
                 while(s3<>'') do begin
                   s2:=fetch(s3,CRLF);
                   g:=TGeo.Create(); //pro vypnuti optimalizace musime vzdy vytvaret instanci znovu
                   g.id:=s2;
                   if(g.IsSelected() and (s1='SEL')) then Result.Add(s2);
                   if(not g.IsSelected() and (s1='UNSEL')) then Result.Add(s2);
                   g.Free();
                 end;
                 DeleteFiles(f);
               end;
             end;
      'ALL': begin
               f:=Geoget_Datadir+'\'+GGT_TEMP_FILENAME;
               GeoListSave(f);
               if(FileExists(f)) then begin
                 s:=trim(s+CRLF+FileToString(f));
                 DeleteFiles(f);
               end;
             end;
      else if(s1<>'') then Result.Add(s1);
    end;
  end;
end;
//------------------ obsluha a provadeni akci davky --------------------------
procedure RunInfoDialogFree;
begin
  if(dInfoBar<>nil) then begin dInfoBar.Free; dInfoBar:=nil; end;
  if(dInfoAbort<>nil) then begin dInfoAbort.Free; dInfoAbort:=nil; end;
  if(dInfoStart<>nil) then begin dInfoStart.Free; dInfoStart:=nil; end;
  if(dInfoKrok<>nil) then begin dInfoKrok.Free; dInfoKrok:=nil; end;
  if(dRunInfo<>nil) then begin dRunInfo.Close(); dRunInfo.Free; dRunInfo:=nil; iRunInfo:=0; end;
end;

procedure RunInfoAbortOnClick(sender:TObject);
begin
  //ShowMessage('Prerusit davku');
  RunInfoDialogFree();
  GeoAbort();   //zda se ovsem, ze tohle prerusi misto celeho scriptu jen
                //nemodalni dialog a script bude prerusen az po ukonceni prave
                //probihajici operace
end;

procedure CreateRunInfoDialog;
begin
  dRunInfo:=TForm.Create(nil);
  dRunInfo.BorderStyle:=bsDialog;
  dRunInfo.FormStyle:=fsStayOnTop;
  dRunInfo.BorderIcons:=[];
  dRunInfo.Caption:=_('Combine - progress of batch');
  dRunInfo.Position:=poDesigned;
  dRunInfo.Height:=130;
  dRunInfo.Width:=500;
  dRunInfo.Top:=10;
  dRunInfo.Left:=10;
  dInfoKrok:=TLabel.Create(dRunInfo);
  dInfoStart:=TLabel.Create(dRunInfo);
  dInfoAbort:=TButton.Create(dRunInfo);
  dInfoBar:=TProgressBar.Create(dRunInfo);       //graficke znazorneni pokroku
  with dInfoKrok do begin
    Parent:=dRunInfo; Caption:=''; Hint:='';
    Top:=30; Left:=6; Width:=490; Height:=20;
    Autosize:=false; Alignment:=taLeftJustify;
    Font.Height:=-12; Font.Style:=[fsBold];
  end;
  with dInfoStart do begin
    Parent:=dRunInfo; Caption:=''; Hint:='';
    Top:=7; Left:=6; Width:=490; Height:=16;
    Autosize:=false; Alignment:=taLeftJustify;
    Font.Height:=-12; //Font.Style.fsBold:=false;
  end;
  with dInfoBar do begin
    Parent:=dRunInfo; Hint:='';
    Top:=50; Left:=6; Width:=480; Height:=16;
    Step:=10; Smooth:=true;
  end;
  with dInfoAbort do begin
    Parent:=dRunInfo; Caption:=_('Break the batch'); Hint:='';
    Top:=72; Left:=200; Width:=100; Height:=26;
    Font.Height:=-12;
    OnClick:=@RunInfoAbortOnClick;
  end;
  dRunInfo.Visible:=false;
end;

function QuestionContinue(text:string):integer;
begin //zobrazi text a opta se, zda pokracovat
  Result:=MessBox(text+CRLF+CRLF+_('Continue processing?')+CRLF+CRLF
    +_('Yes ... execute the command')+CRLF
    +_('No ... skip the command')+CRLF
    +_('Cancel ... interrupts the processing of batch'),
    _('Debugging'),3);
  case Result of
    6: Result:=1; //provest
    7: Result:=0; //peskocit prikaz
    2: Result:=-1; //ukoncit zpracovani davky
    else Result:=1;
  end;
end;

function GetIntFromText(s:string):integer;
begin //odpare pripadne uvozovky a vrati jako int
  if(copy(s,1,1)='"') then Result:=StrToInt(copy(s,2,length(s)-2))
  else Result:=StrToInt(s);
end;

function ProcFtp(sFce,sLocal,sFtp:string):boolean;
var sServer,sPort,sFile,sUser,sPwd,s:string;
begin
  //rozeberem informace pro FTP server
  Result:=false;
  sFile:=sFtp;
  sUser:=fetch(sFile,';');
  sPwd:=fetch(sFile,';');
  if(copy(sFile,1,6)='ftp://') then s:=fetch(sFile,'//');
  sPort:=fetch(sFile,'/');
  sServer:=fetch(sPort,':');
  if(sPort='') then sPort:='21';  //port neni zadan, pouzijeme implicitni
  s:=ReplaceString(sLocal,'/','\'); //dame sptavne oddelovace
  if(sPwd<>'') and (sUser<>'') and (sFile<>'') and (sPort<>'') and (sServer<>'')
    and (sFile<>'') then begin
    if(sFce='GET') then Result:=FtpGetFile(sServer,sPort,sFile,s,sUser,sPwd);
    if(sFce='PUT') then Result:=FtpPutFile(sServer,sPort,sFile,s,sUser,sPwd);
  end;

  if(not Result) then ShowMessage('FTP error:'+CRLF+CRLF
    +'Funkce: '+sFce+CRLF
    +'sServer: '+sServer+CRLF
    +'sPort: '+sPort+CRLF
    +'sFile: '+sFile+CRLF
    +'sUser: '+sUser+CRLF
    +'sPwd: '+sPwd+CRLF
    +'sLocalFile: '+s+CRLF);

end;

function PromptForDb:string;
//necha uzivivatele vybrat databazi
//protoze do Combine.lib neni mozne pouzit 'uses Formular' a protoze
//pri volani z ulozene davky na toolbar neni pouzit Combine.ggp.pas,
//musime formular vytvorit online tady
var frm:TForm;
    OK:TButton;
    ListDB:TListBox;
    i,border,basew:Integer;
    
begin
  Result:='';
  border:=10;
  basew:=198; 
  Frm:=TForm.Create(nil);
  Frm.Caption:=_('Select database');
  Frm.Position:=poScreenCenter;
  Frm.width:=basew+2*border;
  Frm.Height:=245;
  Frm.BorderStyle:=bsDialog;
  Frm.BorderIcons:=[];

  ListDB:=TListBox.Create(Frm);
  ListDB.Top:=8; ListDB.Left:=6; ListDB.Width:=200; ListDB.Height:=173;
  ListDB.ItemHeight:=16; ListDB.Sorted:=true;
  ListDB.Parent:=Frm;
  GeoDbNames(ListDB.Items);

  OK:=TButton.Create(Frm);
  OK.top:=187; 
  OK.left:=70;
  OK.height:=25; OK.width:=75;
  OK.Caption:='OK'; OK.Default:=true; OK.ModalResult:=1; //OK.TabOrder:=0;
  OK.Parent:=Frm;
  while ((i<>1) or (ListDB.ItemIndex<0)) do begin
    i:=Frm.ShowModal();
  end;
  Result:=ListDB.Items[ListDB.ItemIndex];
  OK.Free();
  ListDB.Free();
  Frm.Free();
end;                                 
  
procedure RunGgCmd(cmd,par:string);
var p1,p2,p3,p4,s:string;
  ini:TIniFile;
  //iniM:TMemInifile;
  i,i1,i2:integer;
  aList,aList2:TStringList;
  aColList:TColList;
  bod:TGeo;
  aReg:TRegistry;
  rApiCfg:TGCLSearch;        //struktura parametru pro nacteni listingu kesi
  //dType:TRegDataType;
begin
  if(GeoBusyTest()) then iContinue:=-1;
  if((iContinue>=0) and (cmd<>'')) then begin
    p1:=fetch(par,'|'); p2:=fetch(par,'|');
    p3:=fetch(par,'|'); p4:=fetch(par,'|'); //ostatni nepotrebujeme
{$ifdef DEBUG_HELPER}
  LDHD('RunGgCmd(): cmd='+cmd+CRLF+'p1='+p1+CRLF+'p2='+p2+CRLF+'p3='+p3+CRLF+'p4='+p4+CRLF,ldhInfo);
{$endif}
    case cmd of
    'Stop': begin
              if(bDebug) then iContinue:=QuestionContinue(cmd+_(' - Terminate batch processing'));
              if(iContinue>0) then iContinue:=-1;
            end;
    'StopThis': begin
              if(bDebug) then iContinue:=QuestionContinue(cmd+_(' - Terminate batch processing (this only)'));
              if(iContinue>0) then iContinue:=-2;
            end;
    'Debug': begin
              if(bDebug) then iContinue:=QuestionContinue(cmd+_(' - Set displaying/hidding debug logs'));
              if(iContinue>0) then bDebug:=((p1='1') or (p1='START'));
            end;
    'HideImportResults': begin
                if(bDebug) then iContinue:=QuestionContinue(cmd+_(' - Hide the result of import'));
                if(iContinue>0) then bHideImportResults:=true;
              end;
    'ImpFile':begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(not bHideImportResults) then GeoImportBegin;
                  if(bDebug) then iContinue:=QuestionContinue(_('Import file:')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    if(FileExists(p1)) then begin
                      GeoImportFile(p1);
                      sLastRet:='1';
                    end else ShowMessage(cmd+': '+_('File not found:')+CRLF+p1);
                    if(not bHideImportResults) then GeoImportEnd;
                  end;
                  bHideImportResults:=false;
                end;
              end;
    'ImpDir': //cesta musi koncit lomitkem, pokud nekonci, doplnime ji
              begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(copy(par,length(p1)-1,1)<>'\') then p1:=p1+'\';
                  if(not bHideImportResults) then GeoImportBegin;
                  if(bDebug) then iContinue:=QuestionContinue(_('Import directory:')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    GeoImportDir(p1);
                    if(not bHideImportResults) then GeoImportEnd;
                  end;
                  bHideImportResults:=false;
                  sLastRet:='1';
                end;
              end;
    'ImpPQ': begin
               sLastRet:='0';
               if(not bHideImportResults) then GeoImportBegin;
               if(bDebug) then iContinue:=QuestionContinue(_('Import of Pocket Query'));
               if(iContinue>0) then begin
                 GeoImportPQ;
                 if(not bHideImportResults) then GeoImportEnd;
               end;
               bHideImportResults:=false;
               sLastRet:='1';
             end;
    'GetPQ': begin
               sLastRet:='0';
               if(not bHideImportResults) then GeoImportBegin;
               if(bDebug) then iContinue:=QuestionContinue(_('Download and import of Pocket Query'));
               if(iContinue>0) then begin
                 GeoDownImportPQ;
                 if(not bHideImportResults) then GeoImportEnd;
               end;
               bHideImportResults:=false;
               sLastRet:='1';
            end;
    'FileDel': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Delete file')+CRLF+'   '+p1);
                  if(iContinue>0) then DeleteFiles(p1);
                  sLastRet:='1';
                end;
              end;
    'TextToFile': begin
                sLastRet:='0';
                //protoze text muze obsahovat i svislitka, je treba nacist p2 a p3 znovu a lepe
                //(p3 jako text za poslednim svislitkem p2 jako text mezi prvnim a poslednim
                //svislitkem)
                //ShowMessage('p1='+p1+CRLF+'p2='+p2+CRLF+'p3='+p3+CRLF+'p4='+p4+CRLF);
                s:=p1+'|'+p2;
                if(p3<>'') then s:=s+'|'+p3;
                if(p4<>'') then s:=s+'|'+p4;
                if(par<>'') then s:=s+'|'+par;
                p2:=RegexSubstitute('.*\|(.*)',s,'$1');
                p1:=RegexSubstitute('(.*)\|.*',s,'$1');
                //ShowMessage('s='+s+CRLF+'p1='+p1+CRLF+'p2='+p2+CRLF+'p3='+p3+CRLF+'p4='+p4+CRLF);
                if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  p3:=Fetch(p1,':');
                  if((p1='') and ((p3<>'0') or (p3<>'1') or (p3<>'WRITE') or (p3<>'ADD'))) then
                    ShowMessage(cmd+': '+_('Wrong command format')+', '+_('may be missing')+CRLF
                      +_('flag "WRITE:" or "ADD:"')+CRLF
                      +_('The command might not work properly.'));
                  if(bDebug) then begin
                    if(p3='1') then p4:=_('Add text: ') else p4:=_('Text to a file: ');
                    iContinue:=QuestionContinue(p4+p1+CRLF+CRLF+_('File:')+p2);
                  end;
                  if(iContinue>0) then begin
                    if(p3='1') or (p3='ADD') then p4:=FileToString(p2)
                    else p4:='';
                    p4:=p4+ReplaceProm(ReplaceString(p1,'\n',CRLF));
                    StringToFile(p4,p2);
                  end;
                  sLastRet:='1';
                end;
              end;
    'FileExists': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Check for file existence')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    bLastTest:=true;
                    if(p1[2]=':') then begin //zkontrolujeme pripravenost disku
                      bLastTest:=DiskInDrive(p1[1]);
                      //ShowMessage('FFF Pripravenost disku '+p1[1]+': '+IntToStr(bLastTest as integer));
                    end;
                    if(bLastTest) then bLastTest:=FileExists(p1);
                    if(bLastTest) then sLastRet:='1';
                  end;
                  bIsBLastTest:=true;
                end;
              end;
    'FileRen':begin
                sLastRet:='0';
                if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Rename the file')+CRLF+'   '+p1+CRLF+'=>'+p2);
                  if(iContinue>0) then begin
                    if(FileExists(p1)) then begin
                      DeleteFile(p2);
                      RenameFile(p1,p2);
                      sLastRet:='1';
                    end else ShowMessage(cmd+': '+_('File not found:')+CRLF+p1);
                  end;
                end;
              end;
    'FileCopy':begin
                 sLastRet:='0';
                 if((p1='') or (p2='')) then begin
                   ShowMessage(cmd+': '+_('Missing a required parameter')+CRLF+
                     'p1='+p1+CRLF+'p2='+p2);
                 end
                 else begin
                   if(bDebug) then iContinue:=QuestionContinue('Copy the file'+CRLF+'   '+p1+CRLF+'=>'+p2);
                   if(iContinue>0) then begin
                     DeleteFile(p2);
                     GeoBusyKind(cmd+': '+p1);
                     if(not CopyFile(p1,p2)) then ShowMessage('ERR: '+_('copy the file ')+CRLF+'   '+p1+CRLF+'=>'+p2)
                     else sLastRet:='1';
                   end;
                 end;
               end;
    'DelTree': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Delete directory')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    GeoBusyKind(cmd+': '+p1);
                    DelTree(p1);
                  end;
                  sLastRet:='1';
                end;
              end;
    'EmptyDir': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Delete the content of the directory')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    GeoBusyKind(cmd+': '+p1);
                    DelTree(p1);
                    ForceDirectories(p1);
                  end;
                  sLastRet:='1';
                end;
              end;
    'INIReadValue': begin
                sLastRet:='0';
                if(p1='') or (p2='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Read value from INI file')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    if(not FileExists(p1)) then begin
                      ShowMessage(cmd+': '+_('File not found:')+CRLF+p1);
                    end else begin
                      GeoBusyKind(cmd+': '+p1);
                      p3:=Fetch(p2,';'); //jmeno sekce
                      p4:=Fetch(p2,';'); //promenna
                      s:=Fetch(p2,';'); //implicitni hodnota, v p2 zustalo jmeno promenne
                      ini:=TIniFile.Create(p1);
                      try
                        ReplaceSet(p2,ini.ReadString(p3,p4,s));
                        sLastRet:='1';
                      finally
                        ini.Free();
                      end;
                    end;
                  end;
                end;
              end;
    'INIWriteValue': begin
                sLastRet:='0';
                //protoze zapisovanz text muze obsahovat svislitka, musime
                //parametry spojit do zapisovaneho textu
                if(p3<>'') then p2:=p2+'|'+p3;
                if(p4<>'') then p2:=p2+'|'+p4;
                if(par<>'') then p2:=p2+'|'+par;
                if(p1='') or (p2='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Write value into INI file')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    GeoBusyKind(cmd+': '+p1);
                    //if(not FileExists(p1)) then StringToFile('',p1); //vytvorime soubor
                    p3:=Fetch(p2,';'); //jmeno sekce
                    p4:=Fetch(p2,';'); //promenna, v p2 zustala hodnota
                //ShowMessage('soubor='+p1+CRLF+'text='+p2+CRLF+'sekce='+p3+CRLF+'promenna='+p4+CRLF);
                    ini:=TIniFile.Create(p1);
                    //try
                 //zajimave, ze ted zapis nefunguje, nezapise to ani znak, podle me to chodilo, kdyz jsem to udelal
                     ini.WriteString(p3,p4,p2);
                     ini.UpdateFile();
                      sLastRet:='1';
                    //finally
                      ini.Free();
                    //end;
                  end;
                end;
              end;
    'FtpGetFile': begin
                sLastRet:='0';
                if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Retrieve a file from an FTP server')+CRLF+'   '+p1+CRLF+'   '+p2);
                  if(iContinue>0) then begin
                    if(ProcFtp('GET',p2,p1)) then sLastRet:='1';
                  end;
                end;
              end;
    'FtpPutFile': begin
                sLastRet:='0';
                if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Write file to an FTP server')+CRLF+'   '+p1+CRLF+'   '+p2);
                  if(iContinue>0) then begin
                    if(ProcFtp('PUT',p1,p2)) then sLastRet:='1';
                  end;
                end;
              end;
    'HttpGet': begin
                sLastRet:='0';
                if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Get file from URL')+CRLF+'   '+p1+CRLF+'save to:'+CRLF+p2);
                  if(iContinue>0) then begin
                    if(HttpAsk('GET',p1,''{MIME string},''{upload date},p3)) then begin
                      StringToFile(p3,p2);
                      sLastRet:='1';
                    end;
                  end;
                end;
              end;
    'FileToGsProfile': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Write the file to the profile on geocaching.com')+CRLF+'   '+p1);
                  p4:=GEOGET_SCRIPTDIR+'\geojarry\geojarryw.exe';
                  if(iContinue>0) then begin
                    if(not FileExists(p4)) then //otestujeme existenci geojarryw.exe
                      ShowMessage('ERR: '+_('The file can not be transferred to the profile, Geojarry plugin is not installed.'))
                    else begin
                      //vyvorime ini pro  gjw
                      p2:=ReplaceProm(GetCombineDir()+'Temp\%GS_USERNAME%.session.txt');
                      p3:=ReplaceProm('[geojarry]'+CRLF
                        +'username=%GS_USERNAME%'+CRLF
                        +'password=%GS_PASSWORD%'+CRLF
                        +'proxyip='+GEOGET_PROXYHOST+CRLF
                        +'proxyport='+GEOGET_PROXYPORT+CRLF
                        +'proxyuser='+GEOGET_PROXYUSER+CRLF
                        +'proxypass='+GEOGET_PROXYPASS+CRLF
                        +'sessionfile='+p2+CRLF
                        +'datadir='+GetCombineDir()+'Temp\'+CRLF);
                      ForceDirectories(GetCombineDir()+'Temp\');
                      DeleteFiles(GetCombineDir()+'Temp\*.*');
                      StringToFile(p3,GetCombineDir()+'Temp\gjini.txt');
                      //zavolame gjw pro zapis do do profilu
                      p3:='"'+GEOGET_SCRIPTDIR+'\geojarry\geojarryw.exe" "'
                        +GetCombineDir()+'Temp\gjini.txt" profile "'+p1+'"';
                      i:=RunExec(p3);
                      if(i=0) then sLastRet:='1'
                      else ShowMessage('ERR: '+_('Geojarry run-time error: ')+IntToStr(i));
                    end;
                  end;
                end;
              end;
    'CreateDir': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Create a directory')+CRLF+'   '+p1);
                  if(iContinue>0) then ForceDirectories(p1);
                  end;
                  sLastRet:='1';
                end;
    'ListClear': begin
                 if(bDebug) then iContinue:=QuestionContinue(_('Clear the list of displayed points'));
                 if(iContinue>0) then GeoListClear;
                 sLastRet:='1';
                 end;
    'ListSaveGgt': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  p1:=RelToAbsFilename(p1,GEOGET_DATADIR);
                  if(bDebug) then iContinue:=QuestionContinue(_('Save a list of displayed points in')+CRLF+'   '+p1);
                  if(iContinue>0) then GeoListSave(p1);
                  sLastRet:='1';
                end;
              end;
    'ListSelectAll':  begin;
                 p1:=Geoget_Datadir+'\'+GGT_TEMP_FILENAME;
                 if(bDebug) then iContinue:=QuestionContinue(_('Select all displayed points in the list'));
                 if(iContinue>0) then begin
                   GeoListSave(p1);
                   if(FileExists(p1)) then begin
                     GeoListFileAdd(p1);
                     DeleteFiles(p1);
                   end;
                 end;
                 sLastRet:='1';
                 end;
    'ListDeleteFromXToEnd':  begin;
                 p2:=Geoget_Datadir+'\'+GGT_TEMP_FILENAME;
                 if(bDebug) then iContinue:=QuestionContinue(_('Keep the list in the first X points.'));
                 if(iContinue>0) then begin
                   GeoListSave(p2);
                   aList:=TStringList.Create();
                   if(FileExists(p2)) then begin
                     aList.LoadFromFile(p2);
                     bod:=TGeo.Create()
                     for i:=StrToInt(p1) to aList.Count-1 do begin
                       bod.LoadByGc(aList[i]);
                       if(bod.id<>'') then bod.ListDel();
                       if(GeoBusyTest()) then begin
                         iContinue:=-1;
                         break;
                       end;
                     end;
                   end;
                   aList.Free;
                   DeleteFiles(p2);
                 end;
                 sLastRet:='1';
                 end;
    'ListRefresh': begin
                  sLastRet:='0';
                  if(bDebug) then iContinue:=QuestionContinue(_('Refresh the list of displayed points in')+CRLF+'   '+p1);
                  if(iContinue>0) then GeoListUpdateAll();
                  sLastRet:='1';
                end;
    'ListCount': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue('Save number of listed items to variable:'+'   '+p1);
                  if(iContinue>0) then begin
                    p2:=Geoget_Datadir+'\'+GGT_TEMP_FILENAME;
                    GeoListSave(p2);
                    if(FileExists(p2)) then begin
                      aList:=TStringList.Create();
                      aList.LoadFromFile(p2);
                      bod:=TGeo.Create();
                      ReplaceSet(p1,IntToStr(aList.Count));
                      aList.Free();
                      DeleteFiles(p2);
                      end
                      else ReplaceSet(p1,'0');
                    end;
                  sLastRet:='1';
                end;
              end;
    'ListSelectedSaveGgt': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Save list of selected caches to ')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                     p4:=Geoget_Datadir+'\'+GGT_TEMP_FILENAME;
                     GeoListSave(p4);
                     if(FileExists(p4)) then begin //pokud je seznam prazdny, soubor se nevytvori
                       p3:=trim(FileToString(p4));
                       s:='';
                       //pred pridanim zkontrolujeme kazdou kes, zda je mezi oznacenymi
                       while(p3<>'') do begin
                         bod:=TGeo.Create();    //musi byt v cyklu, aby se potlacila optimalizace zachazeni s instanci tridy
                         p2:=fetch(p3,CRLF);
                         bod.id:=p2;
                         if(bod.IsSelected()) then s:=s+p2+CRLF;
                         bod.Free();
                       end;
                       DeleteFiles(p4);
                         //ShowMessage('YYYY: '+p1+CRLF+s);
                       StringToFile(s,p1);
                     end;
                    sLastRet:='1';
                  end;
                end;
              end;
    'ListRemovePermanent': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Permanently remove poins: ')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                     p4:=Geoget_Datadir+'\'+GGT_TEMP_FILENAME;
                     GeoListSave(p4);
                     if(FileExists(p4)) then begin //pokud je seznam prazdny, soubor se nevytvori
                       p3:=trim(FileToString(p4));
                       s:='';
                       //pred pridanim zkontrolujeme kazdou kes, zda je mezi oznacenymi
                       while(p3<>'') do begin
                         bod:=TGeo.Create(); //pro vypnuti optimalizace musime vzdy vytvaret instanci znovu
                         p2:=fetch(p3,CRLF);
                         bod.LoadByGC(p2); //tady nestaci nastavit ID, musi se takto, jinak
                                              //dojde k vymazani obsahu bodu, ale ne k jeho zruseni
                         if((p1='ALL') or ((p1='SEL') and (bod.IsSelected()))) then begin
                           bod.Remove();
                         end;
                         bod.Free();
                       end;
                       DeleteFiles(p4);
                     end;
                    sLastRet:='1';
                  end;
                end;
              end;
    'ListChangeGcl':begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Change columns to: ')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    if(p1<>GeoGet_Columns.Filename) then begin
                      sLastRet:='2'; //jiz je nastaveno z drivejska
                      if(FileExists(p1)) then begin
                        aColList:=TColList.Create();
                        aColList.LoadFromFile(p1);
                        GeoGet_Columns.AssignList(aColList);
                        GeoRefreshHeaders();
                        //if(sListFile<>sListFileActual) then aColList.Free();
                        sLastRet:='1'; //nastaveno jako aktualni
                      end;
                    end;
                  end;
                end;
              end;
    'GgtCount': begin
                sLastRet:='0';
                if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Save number of items GGT file')+CRLF+p2+CRLF+_('to variable:')+'   '+p1);
                  if(iContinue>0) then begin
                    if(FileExists(p2)) then begin
                      aList:=TStringList.Create();
                      aList.LoadFromFile(p2);
                      ReplaceSet(p1,IntToStr(aList.Count));
                      aList.Free();
                      aList:=nil;
                      end else ReplaceSet(p1,'0');
                    end;
                  sLastRet:='1';
                end;
              end;
    'GgtAddGgt': begin
                sLastRet:='0';
                if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Adding GGT files')+CRLF+p1+CRLF+p2);
                  if(iContinue>0) then begin
                    if(FileExists(p1)) then begin
                      aList:=TStringList.Create();
                      aList.LoadFromFile(p1);
                      for i:=0 to aList.count-1 do aList[i]:=Trim(aList[i]);
                      if(FileExists(p2)) then begin
                        aList2:=TStringList.Create();
                        aList2.LoadFromFile(p2);
                        for i:=0 to aList2.count-1 do aList2[i]:=Trim(aList2[i]);
                        for i:=0 to aList2.count-1 do begin
                          if(aList.indexOf(aList2[i])=-1) then aList.Add(aList2[i]);
                          //ShowMessage('SSSS testuji '+aList2[i]+', pocet kesi v seznamu: '+IntToStr(aList.Count));
                        end;
                      end;
                      //ulozime soubor zpet a uklidime po sobe
                      aList.SaveToFile(p1);
                      if(aList<>nil) then aList.Free(); aList:=nil;
                      if(aList2<>nil) then aList2.Free(); aList2:=nil;
                    end;
                  end;
                end;
                end;
    'GgtSubGgt': begin
                sLastRet:='0';
                if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Substracting GGT files')+CRLF+p1+CRLF+p2);
                  if(iContinue>0) then begin
                    if(FileExists(p1)) then begin
                      aList:=TStringList.Create();
                      aList.LoadFromFile(p1);
                      for i:=0 to aList.count-1 do aList[i]:=Trim(aList[i]);
                      if(FileExists(p2)) then begin
                        aList2:=TStringList.Create();
                        aList2.LoadFromFile(p2);
                        for i:=0 to aList2.count-1 do begin
                          i1:=aList.indexOf(trim(aList2[i]));
                          if(i1<>-1) then aList.Delete(i1);
                        end;
                        //ulozime soubor zpet
                        aList.SaveToFile(p1);
                      end;
                      //uklidime po sobe
                      if(aList<>nil) then aList.Free(); aList:=nil;
                      if(aList2<>nil) then aList2.Free(); aList2:=nil;
                    end;
                  end;
                end;
                end;
    'GgtSubDb': begin
                sLastRet:='0';
                if((p1='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Substrcting DB from GGT file')+CRLF+p1);
                  if(iContinue>0) then begin
                    if(FileExists(p1)) then begin
                      aList:=TStringList.Create();
                      aList2:=TStringList.Create();
                      aList.LoadFromFile(p1);
                      for i:=0 to aList.count-1 do aList[i]:=Trim(aList[i]);
                      Geoget_DB.GetTableStrings('SELECT id FROM geocache;',aList2);
                      for i:=0 to aList2.count-1 do begin
                        i1:=aList.indexOf(aList2[i]);
                        if(i1<>-1) then aList.Delete(i1);
                      end;
                      //ulozime soubor zpet a uklidime po sobe
                      aList.SaveToFile(p1);
                      if(aList<>nil) then aList.Free(); aList:=nil;
                      if(aList2<>nil) then aList2.Free(); aList2:=nil;
                    end;
                  end;
                end;
                end;
    'SetRefPoint': begin
                sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Set the reference point')+CRLF+'   '+p1);
                  if(iContinue>0) then RefPointSelect(p1);
                  sLastRet:='1';
                end;
              end;
    'CallGroup':begin
                if(bDebug) then iContinue:=QuestionContinue(_('Run another batch')+CRLF+'   '+p1);
                if(iContinue>0) then begin
                  if(FileExists(GetPathnameFromMacroname(p1,'ini'))) then begin
                    GeoBusyKind(cmd+': '+p1);
                    fRunGroup(p1);
                    sLastRet:='1';
                  end else ShowMessage(cmd+': '+_('File not found:')+CRLF+GetPathnameFromMacroname(p1,'ini'));
                end;
                //pokud byla vnorena davka prerusena prikazem StopThis, musi pokracovat tato
                if(iContinue=-2) then iContinue:=1;
                end;
    'BrowseUrl':begin
                if(bDebug) then iContinue:=QuestionContinue(_('Show website:')+CRLF+p1);
                if(iContinue>0) then begin
                  GeoBusyKind(cmd+': '+p1);
                  BrowseUrl(p1);
                  sLastRet:='1';
                end;
                end;
    'RunShell':begin
                p2:=ReplaceString(p2,'|',' '); //oddelime parametry, pokud je jich tam vic
                GeoBusyProgress(1,2);
                if(bDebug) then iContinue:=QuestionContinue(_('Run the program containing file')+CRLF+'   '+p1+CRLF+_('parameters')+CRLF+'   '+p2);
                if(iContinue>0) then begin
                  if(FileExists(p1)) then begin
                    GeoBusyCaption(cmd);
                    GeoBusyKind(_('Processing: ')+p1+' '+p2);
                    RunShell(trim('"'+p1+'"'+' '+p2));
                    GeoBusyProgress(2,2);
                    GeoBusyKind('Shell - '+_('Done'));
                    sLastRet:='1';
                  end else ShowMessage(cmd+': '+_('File not found:')+CRLF+p1);
                end;
                end;
    'RunShellWait': begin
                sLastRet:='0';
                p2:=ReplaceString(p2,'|',' '); //oddelime parametry, pokud je jich tam vic
                GeoBusyProgress(1,2);
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Run the program containing file')+CRLF+'   '+p1+CRLF+_('parameters')+CRLF+'   '+p2);
                  if(iContinue>0) then begin
                    if(FileExists(p1)) then begin
                      GeoBusyCaption(cmd);
                      GeoBusyKind(_('Processing: ')+p1+' '+p2);
                      RunShellWait(trim('"'+p1+'"'+' '+p2));
                      GeoBusyProgress(2,2);
                      GeoBusyKind('Shell - '+_('Done'));
                      sLastRet:='1';
                    end else ShowMessage(cmd+': '+_('File not found:')+CRLF+p1);
                  end;
                end;
              end;
    'RunExec':begin
                p2:=ReplaceString(p2,'|',' '); //oddelime parametry, pokud je jich tam vic
                GeoBusyProgress(1,2);
                if(bDebug) then iContinue:=QuestionContinue(_('Run')+CRLF+'   '+p1+CRLF+_('parameters')+CRLF+'   '+p2);
                if(iContinue>0) then begin
                  if(FileExists(p1)) then begin
                    GeoBusyCaption(cmd);
                    GeoBusyKind(_('Processing: ')+p1+' '+p2);
                    sLastRet:=IntToStr(RunExec(trim('"'+p1+'"'+' '+p2)));
                    //sLastRet:='1';
                    GeoBusyProgress(2,2);
                    GeoBusyKind('Exec - '+_('Done'));
                  end else ShowMessage(cmd+': '+_('File not found:')+CRLF+p1);
                end;
                end;
    'RunExecNoWait':begin
                p2:=ReplaceString(p2,'|',' '); //oddelime parametry, pokud je jich tam vic
                GeoBusyProgress(1,2);
                if(bDebug) then iContinue:=QuestionContinue(_('Run without waiting for completion')+CRLF+'   '+p1+CRLF+_('parameters')+CRLF+'   '+p2);
                if(iContinue>0) then begin
                  if(FileExists(p1)) then begin
                    GeoBusyCaption(cmd);
                    GeoBusyKind(_('Processing: ')+p1+' '+p2);
                    RunExecNoWait(trim('"'+p1+'"'+' '+p2));
                    GeoBusyProgress(2,2);
                    GeoBusyKind(cmd+' - '+_('Done'));
                    sLastRet:='1';
                  end else ShowMessage(cmd+': '+_('File not found:')+CRLF+p1);
                end;
                end;
    'ShowMsg':begin
                p1:=ReplaceString(p1,'\n',CRLF); //spravne zalomeni radku
                if(bDebug) then iContinue:=QuestionContinue(_('Show the message')+CRLF+'   '+p1);
                if(iContinue>0) then ShowMessage(p1);
                sLastRet:='1';
                end;
    'ShowMsgBreak':begin
                  sLastRet:='0';
                  //zobrazime otazku
                  p1:=ReplaceString(p1,'\n',CRLF); //spravne zalomeni radku
                  if(bDebug) then iContinue:=QuestionContinue(_('Show the message with the possibility of interruption')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    i:=MessBox(p1+CRLF+CRLF+_('Continue processing?'),
                      _('The possibility of interruption processing batch'),4);
                    if(i=7) then begin  iContinue:=-1; sLastRet:='1'; end;
                  end;
                end;
    'ShowRunInfo':begin
                  if(StrToInt(p1)=-1) then dRunInfo.Hide()
                  else begin
                    //zjistime rozmery obrazovky pro spravne umisteni dialogu
                    dRunInfo.Show();
                    if(p2='') then begin //puvodni zadani, dale nepodporujeme
                      dRunInfo.Top:=10;
                      dRunInfo.Left:=10;
                    end
                    else begin //samostatne zadane X/Y, zaporne hodnoty relativne zprava/zdola
                      dRunInfo.Left:=StrToInt(p1);
                      dRunInfo.Top:=StrToInt(p2);
                      if(dRunInfo.Left<0) then dRunInfo.Left:=Screen.Width-1-dRunInfo.Width;
                      //musime odecist i vysku "hlavniho panelu" windows
                      if(dRunInfo.Top<0) then dRunInfo.Top:=Screen.Height-dRunInfo.Height-40-dRunInfo.Top;
                    end;
                  end;
                end;
    //'ShowMsgWait':begin //neumim nemodalni dialog, prikaz nema smysl
    //              p2:=ReplaceString(p2,'\n',CRLF); //spravne zalomeni radku
    //              dText.Caption:=p2;
    //              iTime:=-1;
    //              dWait.Show; //zobrazime nemodalni dialog
    //              doWait(StrToInt(p1));
    //              //a cekame, priznak ukonceni je v iTime
    //              ShowMessage('Ukonceno s hodnotou '+IntToStr(iTime));
    //            end;
    'ShowMsgWait':begin //misto nemodalniho dialogu pouzijeme Busy dialog
                        //bude pak trochu matouci vyznam tlacitka Storno (neukonci
                        //script, ale jen cekani), ale to by nemuselo vadit
                        //vrati do sLastRet=1 ukonceno uplynutim casu
                        //                  2 ukonceno existenci souboru
                        //                  3 preruseno uzivatelem
                    p2:=ReplaceString(p2,'\n',CRLF); //spravne zalomeni radku
                    p3:=Fetch(p1,':');    //zjistime cas cekani a soubor
                    i1:=StrToInt(p3);  //cas v sekundach
                    //if(bDebug) then iContinue:=QuestionContinue(_('Show the message')+CRLF+'   '+p1);
                    if(iContinue>0) then begin
                      //GeoBusyCaption(_('Combine waiting ...'));
                      GeoBusyKind(_('Combine waiting ... ')+p2);
                      for i:=1 to i1 do begin
                        GeoBusyProgress(i,i1);
                        Sleep(1000);
                        if(GeoBusyTest()) then begin
                          GeoBusyStart(); //shodime priznak preruseni, aby se pokracovalo normalnim zpracovanim
                          break;
                        end;
                      if(p1<>'') and (FileExists(p1)) then break;
                        //Sleep(500);
                        //if(GeoBusyTest()) then break;
                      end;
                      if(i>=i1) then sLastRet:='1'
                      else sLastRet:='3';
                      if(p1<>'') and (FileExists(p1)) then sLastRet:='2';
                    end;
                      //GeoBusyCaption('');
                      GeoBusyKind('');
                  end;
    'ShowHtml':begin
                if(bDebug) then iContinue:=QuestionContinue(_('Show the HTML message')+CRLF+'   '+p1);
                if(iContinue>0) then ShowHTMLMessage('',p1);
                sLastRet:='1';
                end;
    'BusyCaption':begin
                p1:=ReplaceString(p1,'\n',CRLF); //spravne zalomeni radku
                if(bDebug) then iContinue:=QuestionContinue(_('Set Busy caption')+CRLF+'   '+p1);
                if(iContinue>0) then GeoBusyCaption(p1);
                sLastRet:='1';
                end;
    'BusyKind':begin
                p1:=ReplaceString(p1,'\n',CRLF); //spravne zalomeni radku
                if(bDebug) then iContinue:=QuestionContinue(_('Set Busy kind')+CRLF+'   '+p1);
                if(iContinue>0) then GeoBusyKind(p1);
                sLastRet:='1';
                end;
    'DBSelect': begin
                  sLastRet:='0';
                  if(p1='') then begin //pokud neni zadna databaze zadana, nechame vybrat
                    p1:=PromptForDb();
                  end;
                  if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(_('Change database to')+CRLF+'   '+p1);
                    if(iContinue>0) then begin
                      GeoBusyKind(cmd+': '+p1);
                      GeoDBSelect(p1);
                      //ReplaceSet('DBName',Geoget_DBName); //zda se, ze GEOGET_DBNAME ma hodnotu stale stejnou jako pri spusteni scriptu
                      ReplaceSet('DBName',p1);
                    end;
                    sLastRet:='1';
                  end;
                end;
    'DBVacuum': begin
                  if(bDebug) then iContinue:=QuestionContinue(_('VACUUM database')+CRLF+'   '+ReplaceProm('%DBName%'));
                  if(iContinue>0) then begin
                    GeoBusyCaption(_('VACUUM of database'));
                    GeoBusyKind(_('The operation can take a minute ...'));
                    GeoBusyValue('');
                    Geoget_DB.ExecSQL('VACUUM'); //nesmi byt v transakci
                  end;
                end;
    'VarSet':   begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Set value of the variable')+CRLF+'   '+p1+' = '+p2);
                  if(iContinue>0) then ReplaceSet(p1,p2);
                  sLastRet:='1';
                end;
    'VarRemove':   begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Remove variable')+'   '+p1);
                  if(iContinue>0) then ReplaceRemove(p1);
                  sLastRet:='1';
                end;
    'VarRet':   begin
                  if(bDebug) then iContinue:=QuestionContinue(_('Save the return value to')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    if(p1<>'') then ReplaceSet(p1,sLastRet)
                    else ShowMessage(cmd+': '+_('Missing variable name'));
                  end;
                end;
    'VarGetYesNo':begin
                  sLastRet:='0';
                  if(p1<>'') then begin
                    p2:=ReplaceString(p2,'\n',CRLF); //spravne zalomeni radku
                    if(bDebug) then iContinue:=QuestionContinue(
                    cmd+': '+CRLF+_('Variable for result:')+p1+CRLF
                    +'    '+p2+CRLF+_('Question:')+CRLF+'    '+p2);
                    if(iContinue>0) then begin
                      i:=MessBox(p2,_('Response value'),4);
                      if(i=6) then begin  ReplaceSet(p1,'1'); sLastRet:='1'; end
                      else ReplaceSet(p1,'0');
                    end;
                  end
                  else ShowMessage(cmd+': '+_('Missing variable name'));
                end;
    'VarGetText':begin
                  sLastRet:='0';
                  if(p1<>'') then begin
                    if(bDebug) then iContinue:=QuestionContinue(cmd+':'+_('Enter value for variable')+CRLF+'   '+p1+CRLF+_('as answer to the question')+CRLF+'   '+p2);
                    if(iContinue>0) then begin
                      p2:=ReplaceString(p2,'\n',CRLF); //spravne zalomeni radku
                      p2:=InputBox(_('Enter a variable value'),p2,'');
                      if(p2<>'') then sLastRet:='1';
                      ReplaceSet(p1,p2);
                    end;
                  end
                  else ShowMessage(cmd+': '+_('Missing variable name'));
                end;
    'VarGetDir':begin
                  sLastRet:='0';
                  if(p1<>'') then begin
                    if(bDebug) then iContinue:=QuestionContinue(
                      cmd+':'+CRLF+_('Variable for directory:')+p1);
                    if(iContinue>0) then begin
                      p3:='';
                      p3:=SelectDir(Geoget_Datadir,p2);
                      ReplaceSet(p1,p3);
                      sLastRet:='1';
                    end;
                  end
                  else ShowMessage(cmd+': '+_('Missing variable name'));
                end;
    'VarGetPathname':begin
                  sLastRet:='0';
                  if(p1<>'') then begin
                    p2:=ReplaceString(p2,'\n',CRLF); //spravne zalomeni radku
                    if(bDebug) then iContinue:=QuestionContinue(
                      cmd+': '+CRLF+_('Variable for pathname:')+p1);
                    if(iContinue>0) then begin
                      p3:='';
                      p3:=GetFileDir(false,'','txt');
                      if(p3<>'') then begin
                      {
                      if(OpenDlg(_('Select the file for a command parameter'),
                                 Geoget_Datadir,'',
                                 _('Text files')+' (*.txt)|*.txt|'+
                                 _('List files')+' (*.ggt)|*.ggt|'+
                                 _('HTML files')+' (*.html; *.htm)|*.html;*.htm|'+
                                 _('Executable files')+' (*.exe; *.com; *.bat; *.cmd)|*.exe; *.bat; *.cmd; *.com|'+
                                 _('Column''s files')+' (*.gcl)|*.gcl|'+
                                 _('Script files')+' (*.pas)|*.pas|'+
                                 _('SQL files')+' (*.sql)|*.sql|'+
                                 _('All files')+' (*.*)|*.*',p3)) then begin
                      }
                        sLastRet:='1';
                      end;
                      ReplaceSet(p1,p3);
                    end;
                  end
                  else ShowMessage(cmd+': '+_('Missing variable name'));
                end;
    'VarTestDefined':  begin
                  sLastRet:='0';
                  bLastTest:=false;
                  if(bDebug) then iContinue:=QuestionContinue(_('Check the variable:')+CRLF+'   '+p1);
                  if(iContinue>0) then begin
                    if(GetVarValue(p1)<>VAR_NOEXIST) then begin
                      sLastRet:='1';
                      bLastTest:=true;
                    end;
                    bIsBLastTest:=true;
                  end;
                end;
    'VarTest':  begin
                  sLastRet:='0';
                  bLastTest:=false;
                  //pokud je misto hodnoty promenna, najdeme jeji hodnotu,
                  //jinak zustane text (hodnota) z prikazu
                  if(GetVarValue(p1)<>VAR_NOEXIST) then p1:=GetVarValue(p1);
                  if(GetVarValue(p2)<>VAR_NOEXIST) then p2:=GetVarValue(p2);
                  if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Evaluation of test')+CRLF+'   '+p1+' '+p3+' '+p2);
                  if(iContinue>0) then begin
                    if(p4='Str') then begin
                      if(p3='=') then bLastTest:=(p1=p2);
                      if(p3='>') then bLastTest:=(p1>p2);
                      if(p3='>=') then bLastTest:=(p1>=p2);
                      if(p3='<') then bLastTest:=(p1<p2);
                      if(p3='<=') then bLastTest:=(p1<=p2);
                      if(p3='<>') then bLastTest:=(p1<>p2);
                    end
                    else if(p4='Int') then begin
                      i1:=GetIntFromText(p1);
                      i2:=GetIntFromText(p2);
                      //ShowMessage('SSSSSS p1='+p1+', p2='+p2+', p3='+p3+', p4='+p4+CRLF
                      //  +'i1='+IntToStr(i1)+', i2='+IntToStr(i2));
                      if(p3='=') then bLastTest:=(i1=i2);
                      if(p3='>') then bLastTest:=(i1>=i2);
                      if(p3='>=') then bLastTest:=(i1>=i2);
                      if(p3='<') then bLastTest:=(i1<i2);
                      if(p3='<=') then bLastTest:=(i1<=i2);
                      if(p3='<>') then bLastTest:=(i1<>i2);
                    end;
                    if(bLastTest) then sLastRet:='1';
                    bIsBLastTest:=true;
                    //ShowMessage('SSSS sLastRet='+sLastRet);
                  end;
                end;
    'VarDateTime':begin
                  sLastRet:='0';
                  if(bDebug) then iContinue:=QuestionContinue(_('Set date/time variables'));
                  if(iContinue>0) then SetVarDateTime;
                end;
    'VarExpr': begin  //ulozi do promenne vysledek SQL dotazu, vzdy prvni hodnotu v tabulce na samostatny radek
                sLastRet:='0';
                if(p1='') or (p2='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  ReplaceSet(p1,''); //inicializovat promennou
                  //pokud soubor existuje, vyraz
                  if(FileExists(p2)) then begin p2:=FileToString(p2); end;
                  p2:='SELECT '+p2;
                  aList:=TStringList.Create;
                  Geoget_DB.GetTableStrings(p2,aList);
                  if(aList.Count>0) then ReplaceSet(p1,aList[0]);
                  aList.Free;
                  sLastRet:='1';
                end;
              end;
    'VarSetGgtAsStringForSqlIn':begin
                  sLastRet:='0';
                if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Make variable from *.ggt file')+CRLF+'   '+p1+CRLF+'   '+p2);
                  if(iContinue>0) then begin
                    //nacist soubor do string, zmenit vsechny CRLF na ','
                    if(FileExists(p2)) then begin
                      p3:=ReplaceString(trim(FileToString(p2)),' ','');
{$ifdef DEBUG_HELPER}
    LDHD('VarSetGgtAsStringForSqlIn: delka nacteneho souboru='+IntToStr(Length(p3)),ldhInfo);
{$endif}
                      p3:=''''+ReplaceString(p3,CRLF,''',''')+'''';
{$ifdef DEBUG_HELPER}
    LDHD('VarSetGgtAsStringForSqlIn: delka ukladana do promenne '''+p1+''':'+IntToStr(Length(p3)),ldhInfo);
{$endif}
                      ReplaceSet(p1,p3);
                      sLastRet:='1';
                    end;
                  end;
                end;
              end;
    'VarIncrement':begin //zvysi hodnotu promenne o zadany krok (i zaporny); pokud neni v promenne ciselna hodnota, zvysuje jen prvni znak (jako ascii kod)
                  sLastRet:='0';
                if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(not RegexFind('[+-]{0,1}[0-9]+',p2)) then p2:='1'; //pokud neni spravne zadany krok, je krok 1
                  if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Increment variable')+CRLF+'  '+p1+' + '+p2);
                  if(iContinue>0) then begin
                    //otestovat, zda v p1 je cislo, pokud ne, vezmeme jen prvni znak
                    i2:=StrToInt(p2);
                    p3:=GetVarValue(p1);
                    //ShowMessage('TTTTT hodnota promenne: '+p3);
                    if(RegexFind('[+-]{0,1}[0-9]+',p3)) then p3:=IntToStr(StrToInt(p3)+i2)
                    else begin
                      //ShowMessage('HHHHH'+CRLF+'p3='+p3+CRLF+'Ord='+IntToStr(Ord(p3//p3[1]:=Chr(Ord(p3[1])+i2);
                      p3[1]:=Chr(Ord(p3[1])+i2);
                    end;
                    ReplaceSet(p1,p3);
                    sLastRet:='1';
                  end;
                end;
              end;
    'VarFromFileRegex':begin
                //musime predelat rozdeleni na parametry
                if(p3<>'') then p2:=p2+'|'+p3;
                if(p4<>'') then p2:=p2+'|'+p4;
                if(par<>'') then p2:=p2+'|'+par;
                p3:=p2;
                p2:=Fetch(p3,'&&'); //oddelime od sebe regularni vyraz a substituci pro vysledek
                p4:=Fetch(p2,'=');     //oddelime od regularniho vyrazu jmeno promenne
                sLastRet:='0';
                if(p1='') or (p2='') or (p3='') or (p4='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Regex from file')+CRLF+p1+CRLF+
                    p4+CRLF+p2+CRLF+p3);
                  if(iContinue>0) then begin
                    s:=RegexSubstitute(p2,FileToString(p1),p3);
                    ReplaceSet(p4,s);
                    sLastRet:='1';
                  end;
                end;
              end;
    'VarFromStringRegex':begin
                //musime predelat rozdeleni na parametry
                if(p3<>'') then p2:=p2+'|'+p3;
                if(p4<>'') then p2:=p2+'|'+p4;
                if(par<>'') then p2:=p2+'|'+par;
                p3:=p2;
                p2:=Fetch(p3,'&&'); //oddelime od sebe regularni vyraz a substituci pro vysledek
                p4:=Fetch(p2,'=');     //oddelime od regularniho vyrazu jmeno promenne
                sLastRet:='0';
                if(p1='') or (p2='') or (p3='') or (p4='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Regex from string')+CRLF+p1+CRLF+
                    p4+CRLF+p2+CRLF+p3);
                  if(iContinue>0) then begin
                    s:=RegexSubstitute(p2,p1,p3);
                    ReplaceSet(p4,s);
                    sLastRet:='1';
                  end;
                end;
              end;
    'VarFilenameFromText': begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(_('Convert text to Filename, save to variable')+CRLF+p1+CRLF+p2);
                    if(iContinue>0) then ReplaceSet(p2,FilenameFromText(p1));
                  end;
                end;
    'VarUrlFromText': begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(_('Convert text to URL, save to variable')+CRLF+p1+CRLF+p2);
                    //prevod ANSI->UTF je kvuli nickum obsahujicim napodenicka, aby byly spravne pro GC.com, gc.cz, ...
                    if(iContinue>0) then ReplaceSet(p2,EncodeUrlElement(AnsiToUtf(p1)));
                  end;
                end;
    'TagAdd':begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(_('Add the TAG value'));
                    //prevedeme z puvodniho ciselneho na nove mnemotechnicke vyjadreni
                    if(p1='0') then p1:='ALL';
                    if(p1='1') then p1:='SEL';
                    if(p1='-1') then p1:='UNSEL';
                    if(iContinue>0) then TagManipulate(p1,'ADD',p2,p3);
                  end;
                end;
    'TagDel':begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(_('Delete the TAG value'));
                    //prevedeme z puvodniho ciselneho na nove mnemotechnicke vyjadreni
                    if(p1='0') then p1:='ALL';
                    if(p1='1') then p1:='SEL';
                    if(p1='-1') then p1:='UNSEL';
                    if(iContinue>0) then TagManipulate(p1,'DEL',p2,p3);
                  end;
                end;
    'TagClear':begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(_('Delete the TAG category'));
                    //prevedeme z puvodniho ciselneho na nove mnemotechnicke vyjadreni
                    if(p1='0') then p1:='ALL';
                    if(p1='1') then p1:='SEL';
                    if(p1='-1') then p1:='UNSEL';
                    if(iContinue>0) then TagManipulate(p1,'CLEAR',p2,TAG_CLEAR);
                  end;
                end;
    'SQLAdd','SQLFileAdd': begin  //Osikovo doplneni
                sLastRet:='0';
                if(p1='' ) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  if(cmd='SQLFileAdd') then begin
                    if(FileExists(p1)) then begin p1:=FileToString(p1); end
                    else begin
                      ShowMessage(cmd+': '+_('file not found: ')+CRLF+p1);
                      p1:='';
                    end;
                  end;
                  p1:=ReplaceProm(p1);
                  //ShowMessage(p1);
                  if(bDebug) then iContinue:=QuestionContinue(_('Run SQL: ')+CRLF+p1);
                  GC:=TGeo.Create;
                  aList:=TStringList.Create();
                  ///// pro SQL prikaz, ktery neni SELECT, by to chtelo uzavrit do
                  ///// transakce
                  Geoget_DB.GetTableStrings(p1,aList);
                  for i:=0 to aList.count-1 do begin
                    GeoBusyProgress(i,aList.count);
                    if(GeoBusyTest()) then begin
                      iContinue:=-1;
                      break;
                    end;
                    //if (IsValidGC(aList[i]) or IsValidWM(aList[i])) then begin
                      GC.LoadByGC(aList[i]);
                    //end
                    //else begin
                    //  GC.LoadByKey(StrToint(aList[i]));
                    //end;
                    if(GC.id='') then begin
                      ShowMessage(_('WARN: Probably unfit SQL. SQL does not return a value ID'));
                      continue; //divne, nepodarilo se nacist :( asi
                    end;
                    if((p2='-1') or (UpperCase(p2)='DEL')) then GC.ListDel
                    else GC.ListAdd;
                    for i1:=0 to GC.Waypoints.Count-1 do begin
                      if(GeoBusyTest()) then begin
                        iContinue:=-1;
                        break;
                      end;
                      if((p2<>'-1') and (UpperCase(p2)<>'DEL')) then GC.Waypoints[i1].ListAdd;
                    end;
                  end;
                  GC.Free;
                  aList.Free;
                  sLastRet:='1';
                end;
              end;
    'SQLToVar': begin  //ulozi do promenne vysledek SQL dotazu, vzdy prvni hodnotu v tabulce na samostatny radek
                sLastRet:='0';
                if(p1='') or (p2='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                else begin
                  //pokud soubor existuje, nacteme z nej SQL, jinak predpokladame, ze je tam primo SQL
                  if(FileExists(p2)) then begin p2:=FileToString(p2); end;
                  //ShowMessage('SQL-1:'+CRLF+p2);
                  p2:=ReplaceProm(p2);  //aby SQL moh obsahovat promenne
                  //ShowMessage('SQL-2:'+CRLF+p2);
                  aList:=TStringList.Create;
                  //ShowMessage('22222 a');
                  ReplaceSet(p1,''); //inicializovat promennou
                  //ShowMessage('22222 b');
                  Geoget_DB.GetTableStrings(p2,aList);
                  //ShowMessage('22222 c');
                  for i:=0 to aList.count-1 do begin
                    GeoBusyProgress(i,aList.count);
                    if(GeoBusyTest()) then begin
                      iContinue:=-1;
                      break;
                    end;
                    ReplaceSet(p1,ReplaceProm('%'+p1+'%')+aList[i]+'\n');
                    //ShowMessage('hodnota: '+aList[i]+CRLF+ReplaceProm('%'+p1+'%'));
                    if GeoBusyTest then break;
                  end;
                  //odpareme koncove pseudoCRLF
                  ReplaceSet(p1,ReplaceString(RegexReplace('\\n$',ReplaceProm('%'+p1+'%'),'',false),'\n','%CRLF%'));
                  aList.Free;
                  sLastRet:='1';
                end;
              end;
    'DBDllRegistration': begin
                if(p1='') then begin
                  ShowMessage(cmd+': '+_('Missing filename.')+CRLF);
                end;
                if(bDebug) then iContinue:=QuestionContinue(cmd+': '
                  +_('Registered DLL:')+CRLF+CRLF+p1);
                if(iContinue>0) then begin
                  Geoget_DB.GetTable('SELECT load_extension('''+p1+''');', false);
                  sLastRet:='1';
                end;
              end;
    'SetRegistryVal':begin
                    sLastRet:='0';
                    p3:=fetch(p1,':'); //klic do p3, jmeno do p1
                    p4:=fetch(p2,':'); //typ do p4, hodnota do p2
                    if(p1='') then begin
                      ShowMessage('RegErr: '+_('Name missing.')+CRLF+CRLF
                        +_('This may be a malformed entry in the batch.')+CRLF
                        +_('Key and name must be separated by a colon!'));
                    end;
                    if(p2='') then begin
                      ShowMessage('RegErr: '+_('Value missing.')+CRLF+CRLF
                        +_('This may be a malformed entry in the batch.')+CRLF
                        +_('Type and value must be separated by a colon!'));
                    end;
                    if(bDebug) then iContinue:=QuestionContinue(cmd+': '
                      +_('Set the value in the windows registry')+CRLF+CRLF
                      +_('Key: ')+p3+CRLF+_('Name: ')+p1+CRLF+_('Type: ')+p4+CRLF+_('Value: ')+p2);
                    if(iContinue>0) then begin
                      if(TestRegistryInput(p3,p1,p4,p2)) then begin
                        try
                          aReg:=TRegistry.Create();
                          s:=fetch(p3,'\'); //oddelime klic od adresare v klici
                          aReg.RootKey:=RegKeyStringToInt(s);
                          aReg.LazyWrite:=false;
                          aReg.OpenKey(p3,true);
                          case p4 of
                          'string': begin aReg.WriteString(p1,p2); end;
                          else ShowMessage('RegERR: '+_('For now you can not write to the registry type other than string.'));
                          end;
                          aReg.CloseKey();
                        finally
                          aReg.Free();
                        end;
                      end;
                    end;
                  end;
    'GetRegistryVal':begin //ulozi do promenne
                  sLastRet:='0';
                  p3:=fetch(p1,':'); //klic do p3, jmeno do p1
                  if(p1='') then begin
                    ShowMessage('RegErr: '+_('Name missing.')+CRLF+CRLF
                      +_('This may be a malformed entry in the batch.')+CRLF
                      +_('Key and Name must be separated by colon!'));
                 end;
                  s:='RegERR: '+_('Unknown error.');
                  if(bDebug) then iContinue:=QuestionContinue(cmd+': '
                    +_('Retrieve the value from windows registry to variable.')+CRLF+CRLF
                    +_('Key: ')+p3+CRLF+_('Name: ')+p1+CRLF+_('Save to variable: ')+p2);
                  if(iContinue>0) then begin
                    if(TestRegistryInput(p3,p1,p2,'XX')) then begin
                      ReplaceSet(p2,'RegErr: '+_('Error accessing registry/key/value.'));
                      try
                        aReg:=TRegistry.Create();
                        aReg.Access:=131097; //nastavime KEY_READ, nepotrebujeme zapis
                        s:=fetch(p3,'\'); //oddelime klic od adresare v klici
                        //aReg.RootKey:=s;   ??### nelze zmenit, nezna RootKey
                        aReg.RootKey:=RegKeyStringToInt(s);
                        aReg.OpenKey(p3,false); //jen pro cteni, to staci
                        s:=aReg.ReadString(p1);
                        sLastRet:='1';
                        //zjistime typ hodnoty podle toho nacteme
                        //case aReg.GetDataType(p1) of
                        //  rdBinary:
                        //  rdUnknown:
                        //  rdString: //begin s:=aReg.ReadString(p1); sLastRet:='1'; end;
                        //  rdExpandString: begin s:=aReg.ReadString(p1); sLastRet:='1'; end;
                        //  rdInteger: begin s:=IntToStr(aReg.ReadInteger(p1)); sLastRet:='1'; end;
                        //  else begin
                        //    ShowMessage('RegERR: prozatim neni mozne nacist z registru hodnotu typu '+s);
                        //    s:='';
                        //  end;
                        //end;
                          aReg.CloseKey();
                        finally
                          aReg.Free();
                        end;
                      end;
                    end;
                    ReplaceSet(p2,s);
                    //ShowMessage('CCCCC s='+s);
                    //DebugShowProm();
                  end;
    'DelRegistryVal':begin
                  sLastRet:='0';
                  if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Delete the value from windows registry.')+CRLF+CRLF
                    +'Klic: '+p1+CRLF+_('Name: ')+p2);
                  if(iContinue>0) then begin
                    if(TestRegistryInput(p1,p2,'string','XX')) then begin
                      try
                        aReg:=TRegistry.Create();
                        s:=fetch(p1,'\'); //oddelime klic od adresare v klici
                        aReg.RootKey:=RegKeyStringToInt(s);
                        aReg.OpenKey(p1,true); //otevrit pro zapis
                        aReg.DeleteValue(p2);
                        aReg.CloseKey();
                      finally
                        aReg.Free();
                      end;
                    end;
                  end;
                end;
    'ApiGetLogs':begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    aList:=ApiMakeList(p2);
                    s:='';
                    //ShowMessage('SSSSS: N='+IntToStr(aList.Count));
                    for i:=0 to (aList.Count-1) do begin
                      s:=s+CRLF+aList[i];
                    end;
                    if(bDebug) then iContinue:=QuestionContinue(_('Download logs for caches: ')+s);
                    if(iContinue>0) then begin
                      //puvodne byl oddelovac strednik, ale to nebylo jednotne
                      //s ostatnimi prikazy, tak aby se stare davky nemusely upravovat
                      p1:=ReplaceString(p1,';',':');
                      p2:=fetch(p1,':');  //pocet logu
                      p3:=fetch(p1,':');  //zastavit po vlastnim logu
                      if(p2='1') then p3:='EXCESS_DEL';
                      if(p3='1') then p3:='MY_STOP';
                      i1:=StrToInt(p2);
                      if(not bHideImportResults) then GeoImportBegin;
                      for i:=0 to aList.Count-1 do begin
                        if(GeoBusyTest()) then begin
                          iContinue:=-1;
                          break;
                        end;
                        //ShowMessage('SSSSS: logy pro: '+aList[i]);
                        GcLiveGetLogs(aList[i],i1,(p3='MY_STOP'),(p1='EXCESS_DEL'));
                      end;
                      if(not bHideImportResults) then GeoImportEnd;
                      sLastRet:='1';
                    end;
                    aList.Free();
                  end;
                end;
    'ApiGgtLogs':begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    s:=FileToString(p2);
                    if(bDebug) then iContinue:=QuestionContinue(_('Download logs for caches: ')+s);
                    if(iContinue>0) then begin
                      aList:=ApiMakeList(s);
                      //puvodne byl oddelovac strednik, ale to nebylo jednotne
                      //s ostatnimi prikazy, tak aby se stare davky nemusely upravovat
                      p1:=ReplaceString(p1,';',':');
                      p2:=fetch(p1,':');  //pocet logu
                      p3:=fetch(p1,':');  //zastavit po vlastnim logu
                      //prevedeme z puvodniho ciselneho formatu, pokud je potreba
                      if(p2='1') then p3:='EXCESS_DEL';
                      if(p3='1') then p3:='MY_STOP';
                      if(not bHideImportResults) then GeoImportBegin;
                      i1:=StrToInt(p2);
                      for i:=0 to aList.Count-1 do begin
                        //ShowMessage('SSSS '+aList[i]);
                        if(GeoBusyTest()) or (iContinue<0) then begin
                          iContinue:=-1;
                          break;
                        end;
                        if(aList[i]<>'') then begin
                          GeoBusyKind(aList[i]);
                          GcLiveGetLogs(aList[i],i1,(p3='MY_STOP'),(p1='EXCESS_DEL'));
                        end;
                        if(GeoBusyTest()) then begin
                          iContinue:=-1;
                          break;
                        end;
                      end;
                      if(not bHideImportResults) then GeoImportEnd;
                      sLastRet:='1';
                      aList.Free();
                    end;
                  end;
                end;
    'ApiUpdateStatus':begin
                  sLastRet:='0';
                  if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    aList:=ApiMakeList(p1);
                    s:='';
                    for i:=0 to aList.Count-1 do s:=s+aList[i]+CRLF;
                    if(bDebug) then iContinue:=QuestionContinue('Update status of caches: '+s);
                    if(iContinue>0) then begin
                      if(not bHideImportResults) then GeoImportBegin;
                      if(s<>'') then GcLiveUpdateStatus(s);
                      if(not bHideImportResults) then GeoImportEnd;
                     sLastRet:='1';
                    end;
                    aList.Free();
                  end;
                end;
    'ApiGgtStatus':begin
                  sLastRet:='0';
                  if(p1='') then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    s:=ReplaceString(FileToString(p1),' ','');
                    if(bDebug) then iContinue:=QuestionContinue('Update status of caches: '+s);
                     if(iContinue>0) then begin
                      if(not bHideImportResults) then GeoImportBegin;
                      if(s<>'') then begin
                        //GeoBusyKind(s);
                        GcLiveUpdateStatus(s);
                      end;
                      if(not bHideImportResults) then GeoImportEnd;
                      sLastRet:='1';
                    end;
                  end;
                end;
    'ApiUpdateListing':begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    aList:=ApiMakeList(p1);
                    for i:=0 to aList.Count-1 do s:=s+aList[i]+CRLF;
                    if(bDebug) then iContinue:=QuestionContinue('Update listings of caches: '+s);
                    if(iContinue>0) then begin
                      if(not bHideImportResults) then GeoImportBegin;
                      if(p2='0') then p2:='FULL'; //prevedeme z puvodniho 0/1
                      if(s<>'') then GcLiveUpdateListing(s,(p2<>'FULL'){true=Lite-listing, implicitni});
                      if(not bHideImportResults) then GeoImportEnd;
                      sLastRet:='1';
                    end;
                    aList.Free();
                  end;
                end;
    'ApiGgtListing':begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    s:=ReplaceString(FileToString(p1),' ','');
                    if(bDebug) then iContinue:=QuestionContinue(_('Update listings of caches: ')+s);
                    if(iContinue>0) then begin
                      if(not bHideImportResults) then GeoImportBegin;
                      if(p2='0') then p2:='FULL'; //prevedeme z puvodniho 0/1
                      if(s<>'') then GcLiveUpdateListing(s,(p2<>'FULL'){true=Lite-listing, implicitni});
                      if(not bHideImportResults) then GeoImportEnd;
                      sLastRet:='1';
                    end;
                  end;
                end;
    'ApiGetListingsByCfg': begin
                  sLastRet:='0';
                  if((p1='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(_('Get listings of caches by cfg: ')+CRLF+p1);
                    if(iContinue>0) then begin
                      if(not bHideImportResults) then GeoImportBegin;
                      rApiCfg:=ReadApiCfg(p1);      //nacist konfiguracni soubor do struktury
                      if((rApiCfg.cx<>0) and (rApiCfg.cx<>0) and (rApiCfg.cr<>0)) then begin
                        s:='';
                        s:=FloatToStr(rApiCfg.cx)+CRLF
                          +FloatToStr(rApiCfg.cy)+CRLF
                          +FloatToStr(rApiCfg.cr)+CRLF
                          +IntToStr(rApiCfg.islite as integer)+CRLF
                          +rApiCfg.cachetypes+CRLF
                          +rApiCfg.cachesizes+CRLF
                          +IntToStr(rApiCfg.available)+CRLF
                          +IntToStr(rApiCfg.archived)+CRLF
                          +IntToStr(rApiCfg.pmo)+CRLF
                          +IntToStr(rApiCfg.ignorelist as integer)+CRLF
                          +rApiCfg.notfoundby+CRLF
                          +rApiCfg.hiddenby+CRLF
                          +rApiCfg.nothiddenby
                          ;
                        //ShowMessage(s);
                        GcLiveGetListing(rApiCfg);
                        sLastRet:='1';
                      end;
                      if(not bHideImportResults) then GeoImportEnd;
                    end;
                  end;
                end;
    'ApiGetUserLogs': begin
                  sLastRet:='0';
                  if((p1='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Get all logs of user')+' '+p1);
                    if(iContinue>0) then begin
                      if(not bHideImportResults) then GeoImportBegin;
                      GCLiveGetUserLogs(AnsiToUtf(p1));
                      if(not bHideImportResults) then GeoImportEnd;
                      sLastRet:='1';
                      end;
                    end;
                  end;
    'ApiUpdateUserLogs': begin
                  sLastRet:='0';
                  if((p1='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Update logs of user')+' '+p1);
                    if(iContinue>0) then begin
                      if(not bHideImportResults) then GeoImportBegin;
                      GCLiveUpdateUserLogs(AnsiToUtf(p1));
                      if(not bHideImportResults) then GeoImportEnd;
                      sLastRet:='1';
                      end;
                    end;
                  end;
    'ApiBookmarkGetGuid': begin
                  sLastRet:='0';
                  if((p1='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Select bookmark, save GUID to variable')+' '+p1);
                    if(iContinue>0) then begin
                      p2:=GCLiveSelectBookmark();
                      if(p2<>'') then ReplaceSet(p1,p2);
                      sLastRet:='1';
                      end;
                    end;
                  end;
    'ApiBookmarkImport': begin
                  sLastRet:='0';
                  if((p1='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Import new caches from bookmark')+' '+p1);
                    if(iContinue>0) then begin
                      if(not bHideImportResults) then GeoImportBegin;
                      GCLiveImportBookmark(p1);
                      if(not bHideImportResults) then GeoImportEnd;
                      sLastRet:='1';
                      end;
                    end;
                  end;
    'ApiBookmarkAddId': begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Add to bookmark')+' '+p1+CRLF+_('ID of caches:')+p2);
                    if(iContinue>0) then begin
                      //zjistime, co vlastne pridat a seznam ulozime do p2
                      //p2=ALL/SEL/UNSEL nebo obsahuje vycet ID kesi (oddelene
                      //   carkou, strednikem nebo mezerou
                      aList:=ApiMakeList(p2);
                      p2:='';
                      for i:=0 to aList.Count-1 do p2:=p2+aList[i]+CRLF;
                      //ShowMessage('Pridat kese: '+p2+' (aList.Count='+IntToStr(aList.Count));
                      aList.Free();
                      GCLiveAddToBookmark(p2,p1);
                      sLastRet:='1';
                      end;
                    end;
                  end;
    'ApiBookmarkList': begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Caches from bookmark')+p1+CRLF+_('to list')+' '+p2);
                    if(iContinue>0) then begin
                      //zjistime jak pridat/odebrat kese ze seznamu
                      GCLiveLoadBookmark(p1);
                      sLastRet:='1';
                      end;
                    end;
                  end;
    'ApiBookmarkToVar': begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Caches from bookmark')+p1+CRLF+_('to variable')+' '+p2);
                    if(iContinue>0) then begin
                      //funkce dostupna az ve verzi 2.7.3
                      p3:=GCLiveGetBookmark(p1);
                      p3:=ReplaceString(p3,CRLF,',');
                      ReplaceSet(p2,p3);
                      sLastRet:='1';
                      end;
                    end;
                  end;
    'ApiBookmarkToGgt': begin
                  sLastRet:='0';
                  if((p1='') or (p2='')) then ShowMessage(cmd+': '+_('Missing a required parameter'))
                  else begin
                    if(bDebug) then iContinue:=QuestionContinue(cmd+': '+_('Caches from bookmark')+p1+CRLF+_('to variable')+' '+p2);
                    if(iContinue>0) then begin
                      //funkce dostupna az ve verzi 2.7.3
                      p3:=GCLiveGetBookmark(p1);
                      StringToFile(p3,p2);
                      sLastRet:='1';
                      end;
                    end;
                  end;
    'TimerMsgToWindow':begin
                p1:=ReplaceString(p1,'\n',CRLF); //spravne zalomeni radku
                if(bDebug) then iContinue:=QuestionContinue(_('Send WindowMessage to Window')+CRLF+'   '+p1);
                if(iContinue>0) then begin
                  TimerMessageInit(p1+'|'+p2);
                end;
                sLastRet:='1';
                end;
    'TimerWaitsUntilRuns':begin
                if(p1='') then p1:='60';
                if(bDebug) then iContinue:=QuestionContinue(_('Waiting until the timer runs')+', '+p1+' sec');
                if(iContinue>0) then begin
                  TimerWaitingToStop(StrToInt(p1));
                end;
                sLastRet:='1';
                end;
    'SetEnvVar': begin
                if(p1='') or (p2='') then ShowMessage(cmd+': '+_('Missing a required parameter'));
                if(bDebug) then iContinue:=QuestionContinue(cmd+': '
                  +_('Set enviroment variable:')+CRLF+CRLF
                  +_('Variable:')+' '+p1+CRLF++_('Value:')+' '+p2);
                if(iContinue>0) then begin
                  Win32SetEnvironmentVariable(p1,p2);
                  sLastRet:='1';
                end;
              end;
    else ShowMessage('Command: '+cmd+' '+par+CRLF+CRLF
          +_('This command is not implemented yet.'));
    end;
  end;
end;

//spusti postupne vsechny akce v davce se zadanym Id
procedure RunGroup(sName:string);
var
  i,iPodminene,nAkci:integer;
  s{,flag},sRun{,typ},par1,sCmd:string;
  aList:TStringList;
  iNeexistuje:integer;
begin
  iContinue:=1;
  bIsbLastTest:=false;
  Inc(iRunInfo);
  SetVarDateTime(); //inicializujeme promenne pro datum a cas
  GeoBusyStart();   //inicializace Busy dialogu, aby sla davka prerusit
  //najdeme a nacteme soubor s prikazy
  s:=GetPathnameFromMacroname(sName,'ini');
//LDH('XXSSSS s='+s+CRLF+'sName='+sName);
  if(not FileExists(s)) then begin
    ShowMessage('RunGroup: '+_('File not found:')+CRLF+CRLF+s);
    exit;
  end;
  aList:=StrToList(FileToString(s));
  nAkci:=aList.Count;
  CreateRunInfoDialog();
  dInfoStart.Caption:=ReplaceProm('Start: %h%:%m%:%s% '+sName);
  //dRunInfo.Show;
  dInfoBar.Min:=0;
  dInfoBar.Max:=nAkci;
  if(nAkci>0) then dInfoBar.Position:=1;
  for i:=1 to aList.Count-1 do begin //na indexu 0 je [Group]
    if(GeoBusyTest()) then begin
      iContinue:=-1;
      break;
    end;
    s:=ReplaceProm(aList[i]);
    if(iRunInfo>0) then begin
      dInfoBar.Position:=i;
      dInfoBar.Refresh();
      dInfoKrok.Caption:=_('Step ')+IntToStr(i)+'/'+IntToStr(aList.Count)+': '+s;
    end;
    sCmd:=fetch(s,'=');
    par1:=s;
    sRun:=fetch(par1,'|'); //prvni parametr
    if(sCmd='') then continue; //ignorujeme prazdne radky
{$ifdef DEBUG_HELPER}
//  LDH('WWWWW iContinue='+IntToStr(iContinue)+CRLF+sRun+CRLF+sCmd);
{$endif}
    if(iContinue<0) then i:=aList.Count-1
    else begin
      //provedeme prikaz
      if(sCmd<>'CMT') and (sCmd<>'GGS') and (sCmd<>'Icon') and (sCmd<>'Comment') and (sCmd<>'Name') then begin
        IsFileOk(sCmd+'='+sRun,sName,true,iNeexistuje);
        //test podmineneho provadeni prikazu
        iPodminene:=0;
        if((copy(sRun,1,1)='+') or (copy(sRun,1,1)='-')) then
        begin
          if(copy(sRun,1,1)='+') then iPodminene:=1;
          if(copy(sRun,1,1)='-') then iPodminene:=-1;
          sRun:=copy(sRun,2,length(sRun)-1);
        end;
        //ShowMessage('XXXX 2: sRun='+sRun);
        if((iPodminene<>0) and (not bIsBLastTest)) then
          ShowMessage(_('Conditional processing is required ')+IntToStr(i)+_('. command:')+CRLF+CRLF
            +'  '+sRun+CRLF+CRLF
            +_('but no test has to be evaluated yet!'));
        //test existence souboru a zmena relativni cesty na absolutni (vrati do filter)
        //vrati plnou cestu
        //if(bLastTest) then s:='true' else s:='false';
        //ShowMessage('XXXX 3: sRun='+sRun+CRLF
        //  +'par1='+par1+CRLF
        //  +'podminene='+IntToStr(iPodminene)+CRLF
        //  +'s='+s+CRLF
        //  );
        if(((iPodminene=1) and (bLastTest)) or
           ((iPodminene=-1) and (not bLastTest)) or
           ((iPodminene=0))) then begin
          case sCmd of
          'GGF_SET': begin
                       if(bDebug) then iContinue:=QuestionContinue(_('View cahces by filter')+CRLF+'   '+sRun);
                       if(iContinue>0) then begin GeoFilterLoadFile(sRun); GeoListLoad; end;
                     end;
          'GGF_ADD': begin
                       if(bDebug) then iContinue:=QuestionContinue(_('Add caches by filter')+CRLF+'   '+sRun);
                       if(iContinue>0) then begin GeoFilterLoadFile(sRun); GeoListLoadAdd; end;
                     end;
          'GGF_SUB': begin
                       if(bDebug) then iContinue:=QuestionContinue(_('Subtract caches by filter')+CRLF+'   '+sRun);
                       if(iContinue>0) then begin GeoFilterLoadFile(sRun); GeoListLoadSub; end;
                     end;
          'GGT_SET': begin
                       if(bDebug) then iContinue:=QuestionContinue(_('View caches by list')+CRLF+'   '+sRun);
                       if(iContinue>0) then begin GeoListClear; GeoListFileAdd(sRun); end;
                     end;
          'GGT_ADD': begin
                       if(bDebug) then iContinue:=QuestionContinue(_('Add caches by list')+CRLF+'   '+sRun);
                       if(iContinue>0) then begin GeoListFileAdd(sRun); end;
                     end;
          'GGT_SUB': begin
                       if(bDebug) then iContinue:=QuestionContinue(_('Subtract caches by list')+CRLF+'   '+sRun);
                       if(iContinue>0) then GeoListFileSub(sRun);
                     end;
          'GGP': begin                       //aplikujeme makro
                 if(bDebug) then iContinue:=QuestionContinue(_('Startup plugin')+CRLF+'   '+sRun);
                 if(iContinue>0) then GeoCallGGP(sRun);
                 end;
          //'GGC': begin GeoCallGGC(sRun,''); end; //aplikujeme makro
          'GGE': begin  //aplikujeme exportni makro
                 if(bDebug) then iContinue:=QuestionContinue(_('Startup exports script')+CRLF+'   '+sRun);
                 if((iContinue>0) and (par1<>'')) then GeoExport(sRun,par1);
                 end;
          'BAT': begin            //aplikujeme bat, parametry pridame ke jmenu
                par1:=ReplaceString(par1,'|',' '); //oddelime parametry, pokud je jich tam vic
                if(bDebug) then iContinue:=QuestionContinue(_('Startup bat')+CRLF+'   '+sRun+CRLF+_('parameters')+CRLF+'   '+par1);
                if(iContinue>0) then begin
                  GeoBusyProgress(1,2);
                  GeoBusyCaption(_('Startup')+' *.bat');
                  GeoBusyKind(_('Works: ')+sRun+' '+par1);
                  RunShell(sRun+' '+par1);
                  GeoBusyProgress(2,2);
                  GeoBusyKind('Bat - '+_('done'));
                end;
                end;
          'EXE': begin
                par1:=ReplaceString(par1,'|',' '); //oddelime parametry, pokud je jich tam vic
                if(bDebug) then iContinue:=QuestionContinue(_('Startup exe')+CRLF+'   '+sRun+CRLF+_('parameters')+CRLF+'   '+par1);
                if(iContinue>0) then begin
                  GeoBusyProgress(1,2);
                  GeoBusyCaption(_('Startup')+' *.exe');
                  GeoBusyKind(_('Works: ')+sRun+' '+par1);
                  //ShowMessage('XXXXX'+CRLF+filter+CRLF+par1);
                  sLastRet:=IntToStr(RunExec(sRun+' '+par1));  //aplikujeme bat/exe (parametry???)
                  GeoBusyProgress(2,2);
                  GeoBusyKind('Exe - '+_('done'));
                end;
                end;
          'CMD': begin
                  if(sRun<>'') then RunGgCmd(sRun,par1);
                end;
          '':; //ignorujeme prazdne radky
          //'lnk':; //se zastupcem nic nedelame, ale nic takoveho by se sem dostat nemelo
          //'bmp':; //s ikonou nic nedelame, ale nic takoveho by se sem dostat nemelo
          else ShowMessage(_('Unknown command: ')+sCmd+CRLF+'prikaz: '+sRun+' '+par1);
          end; //case
        end; //podminene provadeni
      end; //zakomentovane akce
    end; //if else begin
  end; //for
  //pri rekurzivnim volani by se mel dialog uvolnovat az pri poslednim volani!
  Dec(iRunInfo);
  if(iRunInfo<=0) then begin
    RunInfoDialogFree();
    TimerMessageStop();
  end;

  GeoBusyProgress(100,100); //to by melo zabranit zobrazeni '#' na liste spustenych programu
  aList.Free();
end;

//najde a spusti postupne vsechny prikazy patrici do prislusne davky
procedure LoadGroup(sGroup:string);
begin
  RunGroup(sGroup); //jen kvuli kompatibilite se starou verzi ulozenych maker
                    //jinak tato funkce jiz potreba neni
end;

//------------------------------------------------------------------------------
procedure ReadGsUser; //nacte ze souboru groundspeak.config.ggp prihlasovaci
var           //udaje a ulozi je mezi promenne jako GS_USERNAME a GS_PASSWORD
  sPath,s:string;
begin
  sPath:=GEOGET_SCRIPTDIR+'\groundspeak.config.pas';
  if(FileExists(sPath)) then begin
    s:=FileToString(sPath);
    ReplaceAdd('GS_USERNAME',RegExSubstitute('(?is).*gsUsername.*?''(.*?)''', s,'$1'));
    ReplaceAdd('GS_PASSWORD',RegExSubstitute('(?is).*gsPassword.*?''(.*?)''', s,'$1'));
  end;
end;
//------------------------------------------------------------------------------
procedure CombineLibInit;
begin
{$ifdef DEBUG_HELPER} 
  LDHInit(true); 
{$endif}
  //definice zakladnich promennych pro nahradu
  aReplace:=TStringList.Create();
  ReplaceAdd('DBName',GEOGET_DBNAME);
  ReplaceAdd('GG_DATADIR',GEOGET_DATADIR);
  ReplaceAdd('GG_SCRIPTDIR',GEOGET_SCRIPTDIR);
  ReplaceAdd('GG_PROGDIR',GEOGET_PROGPATH);
  ReplaceAdd('GG_CACHER',GEOGET_OWNER);
  ReplaceAdd('GG_OWNER',GEOGET_OWNER);
  ReplaceAdd('GEOGET_OWNER',GEOGET_OWNER); //aby sly pouzit SQL z Geojarry
  ReplaceAdd('CRLF',CRLF);
  SetVarDateTime();   //casove promenne (rok, mesic, den, ...)
  
  ReadGsUser();
  bHideImportResults:=false;
  fRunGroup:=@RunGroup;
  GeoImportBegin; //vynulujeme citace importu pro pripad, ze predchozi importy
                  //nebyly ukonceny a zde bude pouzit prikaz HideImportResults
  //??CreateWaitDialog;
  bLastTest:=true;
  sLastRet:='1';
  //pokud jsme spusteni z nejake davky, musime nastavit spravne pristup
  //k jazykovemu souboru, protoze davka je ulozena v podadresari
  if(GEOGET_SCRIPTNAME<>'Combine.ggp.pas') then begin
    BindTextDomain(GetCurrentTextDomain(), GetCombineDir()+'\Locale\');
    //ShowMessage('XXXXXX bezi davka, '+GEOGET_SCRIPTNAME+CRLF
    //  +'domena: '+GetCurrentTextDomain()+CRLF
    //  +_('Conditional processing is required '));
  end;
end;

procedure CombineLibFree;
begin
  aReplace.Free();
  GeoImportBegin; //vynulujeme citace importu pro pripad, ze predchozi importy
                  //nebyly ukonceny
end;
